#include <stdio.h>
#include <math.h>
#include "wirp.h"

                                                   /* Menues */
static Wcallbf mcbopen,mcbstop,mcbdrwclr,mcbdrwnco,mcbdrwpco; /* callbacks */

static char *mefile="File ,Open ,-----,Exit ";
static Wcallb mcbfile[] = {mcbopen,NULL,mcbstop};

static char *mepop="Drawing,Clear,next color,previous color";
static Wcallb mcbpop[] = {mcbdrwclr,mcbdrwnco,mcbdrwpco};

static int knopf1,bmknopf; /* status for buttons */
static double dsl1,dsl2;   /* value for slider */
static char edittext[20];  /* value for edit */
static int color;

static void mcbstop(char *menitem,int ip1,int ip2) {   /* Menu callbacks */
  wcmessagexy(20,100,"           Auf Wiedersehen             \n"
                     "      und weiterhin viel Spass!        ");
  wloop(); wloop();
  wcloseall();
}
static void mcbopen(char *text,int ip1,int ip2) {
 char *filename=wfileselect("DHM (*.dtm)|All files (*.*)",".","Open");
 if (filename!=NULL) {
  wcmessagexy(20,100,filename);
 }
}
static void mcbdrwclr(char *text,int ip1,int ip2) { drwclear(); drwupdate(); }
static void mcbdrwnco(char *text,int ip1,int ip2) { if (++color>15) color=0; }
static void mcbdrwpco(char *text,int ip1,int ip2) { if (--color<0) color=15; }

static void cb(char *text,int ip1,int ip2) { /* callback for button etc */
 char ch[160];
 sprintf(ch,"cb, text=%s ip1=%d ip2=%d\nknopf1=%d bmknopf=%d\nsl1=%.1f sl2=%.1f\nedit=%s",
                 text,      ip1,   ip2,    knopf1,   bmknopf,     dsl1,  dsl2,  edittext );
 wcmessagexy(20,100,ch);
}

static void fcb(char *text,int ip1,int ip2) { /* callback for drawwindow */
 int mask=wgetevmask();
 static int xl=-1,yl,np;
 sprintf(edittext,"%d %d",ip1,ip2); /* x,y coordinate mousepointer */
 wndraw("Edit1");
 if ((mask&MM_LMBDOWN)!=0) {        /* left mousebutton pressed ? */
  if (xl!=-1) {
   char ch[80];
   drwlinec(xl,yl,ip1,ip2,color);
   drwupdate();
   np++; sprintf(ch,"%d points",np); wnsettext("Text1",ch);
  }
  xl=ip1;yl=ip2;
 }
 if ((mask&MM_RMBDOWN)!=0) {        /* right mousebutton pressed ? */
  wcmenupopup(mepop,mcbpop);
 }
}

                                                   /* main program */
int cmain(int argc,char **argv) {
 double slv1[]={0.0,15.0,1.0,0.0};
  /* slider   start,end,step,step2 */
 double slv2[]={6.0,1.0,20.0,300.0,4000.0,50000.0,600000.0};
  /* slider   number, (number *) value, with listval attribute */
 static char *text[]= {"Zeile 1","Zeile 2","Zeile 3"};
 static char *texta[]={"Auswahl 1","Auswahl 2","Auswahl 3"};
 static char *textc[]={"Auswahl A","Auswahl B","Auswahl C"};
 
 Windowst *frwin;

 wcframe("f0,0,0,500,400,white,tlarge","Titel",NULL); /* main window */
 wcmenuadd(mefile,mcbfile);

 frwin=wcframe("z,200,20,280,360,white,tlarge","",fcb); /* drawing window */
 frwin->mask|=MM_MOVE+MM_LMBUP+MM_LMBDOWN+MM_RMBUP+MM_RMBDOWN; /* event mask */
 drwframename("z");

 wlayout("set",8,20); /* coordinate next element */
 wlayout("row",2,8); /* two in a row, distance 8 */
 wclabel( "Text1,black,tlarge","Textlabel 1");
 wcbutton("b1,check,white,tlarge","Knopf1",        &knopf1,NULL);
 wclabel( "Text2,black,tlarge","Textlabel 2");
 wcbutton("b2,check,green,tlarge","Knopf 2",         NULL,cb);
 wcslider("Gleiter1",slv1,                          &dsl1,cb);
 wcslider("Gleiter2,green,listval,value,tlarge",slv2,&dsl2,NULL);
 wcbutton("BitmapKnopf,,,40,40,black,bitmap",NULL,&bmknopf,NULL);
 wcedit( "Edit1",edittext,sizeof(edittext),cb);
 wclistbox ("ListeSchachtel","Liste",sizeof(text)/sizeof(char *),text,NULL);
 wcradiobox("RadioSchachtel",NULL,   sizeof(texta)/sizeof(char *),0,texta,cb);
 wccombobox("FallSchachtel",textc[0],sizeof(textc)/sizeof(char *),textc,NULL);
 wcbutton("Stopbutton,red,tlarge",NULL,NULL,mcbstop);

 while (wloop()!=0) ; /* wait until wcloseall */
 return 0;
}
