#ifndef MSW
#ifdef XWI
 #define POSX 1
#endif

#include <stdio.h>
#include <string.h>
#ifdef POSX
 #include <dirent.h>
 #include <unistd.h>
#else
 #include <dos.h>
 #include <direct.h>
#endif
#ifdef __WATCOMC__
 void _chdrive(int i) {
  int od;
  _dos_setdrive(i,&od);
 }
#endif

#include "wirp.h"


static Wcallbf fsprevcb;

/*        fileselectbox */
static char fileselected[250];
static char filemask[64];
static int fs_preview=0;
/*fct maskextract */
static void maskextract(char *mask,char *text) {
 char *cl,*cr;
 cl=strstr(text,"(");
 if (cl) cr=strstr(cl,")");
 if (cl && cr) {
  strncpy(mask,cl+1,(cr-cl)-1);
  mask[(cr-cl)-1]=0;
 } else
  strncpy(mask,text,64);
}
/*fct fsfilecb */
static void fsfilecb(char *wname,int i,int j) {
 Windowst *w=wfindname(NULL,wname);
 Liboxst *fra=(Liboxst *)w->ptr;
 getcwd(fileselected,200);
 if (strlen(fileselected)>3)
#ifdef XWI
  strcat(fileselected,"/");
#else
  strcat(fileselected,"\\");
#endif
 strcat(fileselected,((char **)(fra->data))[i-1]);
 wnsettext("_fsel_e",fileselected);
 if (fs_preview) fsprevcb(w->name,fs_preview,1);
/* else            wnclose("_fsel");*/
 return;
}
/*fct fsdirecb */
static void fsdirecb(char *wname,int i,int j) {
 Windowst *w=wfindname(NULL,wname);
#ifdef __SC__
 struct FIND *find;
#endif
#ifdef _BORLANDC_
 struct ffblk fblk;
 int find;
#endif
#ifdef POSX
 DIR *dirp,*dir1;
 struct dirent *direntp;
#endif
 char *fd;
 Liboxst *fra=(Liboxst *)w->ptr;
 fd=((char **)(fra->data))[i-1];
 if (!strcmp(w->name,"_fsel_d")) {
  chdir(fd);
#ifndef XWI
 } else if (!strcmp(w->name,"_fsel_l")) {
  _chdrive(i);
#endif
 } else if (!strcmp(w->name,"_fsel_m")) {
  maskextract(filemask,fd);
 }
 w=wfindname(NULL,"_fsel_d");
 wpboxdelall(w);
#ifdef _BORLANDC_
 find=findfirst("*.*",&fblk,FA_DIREC);
 while (find) {
  if (fblk.attribute&FA_DIREC)
   wpboxadd(w,fblk.name,9999);
  find=findnext(&fblk);
 }
#endif
#ifdef __SC__
 find=findfirst("*.*",FA_DIREC);
 while (find) {
  if (find->attribute&FA_DIREC)
   wpboxadd(w,find->name,9999);
  find=findnext();
 }
#endif
#ifdef POSX
 dirp=opendir(".");
 if (dirp) {
  do {
   direntp=readdir(dirp);
   if (direntp && (dir1=opendir(direntp->d_name))!=NULL) {
    closedir(dir1);
    wpboxadd(w,direntp->d_name,9999);
   }
  } while (direntp);
  closedir(dirp);
 }
#endif
 wpdraw(w);
 w=wfindname(NULL,"_fsel_f");
 wpboxdelall(w);
#ifdef _BORLANDC_
 find=findfirst(filemask,&fblk,0);
 while (find) {
  wpboxadd(w,fblk.name,9999);
  find=findnext(&fblk);
 }
#endif
#ifdef __SC__
 find=findfirst(filemask,0);
 while (find) {
  wpboxadd(w,find->name,9999);
  find=findnext();
 }
#endif
#ifdef POSX
 dirp=opendir(".");
 if (dirp) {
  int nfm=strlen(filemask);
  char filemask1[120];
  if (nfm>120) nfm=120;
  strncpy(filemask1,filemask,nfm-1);
  filemask1[nfm-1]=0;
  do {
   direntp=readdir(dirp);
   if (direntp) {
    if (nfm>1) {
     if (filemask[0]=='*' && !strchr(filemask+1,'*')
      && !strstr(direntp->d_name,filemask+1)) continue;
     if (strchr(filemask,'*') && (strchr(filemask,'*')-filemask) == nfm-1
      && !strstr(direntp->d_name,filemask1)) continue;
    }
    if ((dir1=opendir(direntp->d_name))!=NULL) closedir(dir1);
    else wpboxadd(w,direntp->d_name,9999);
   }
  } while (direntp);
  closedir(dirp);
 }
#endif
 wpdraw(w);
 return;
}
/*fct fscancb */
static void fscancb(char *bname,int i,int j) {
 if (!strcmp(bname,"_fsel_ok")) {
  if (!strcmp(fileselected,"")) return;
 } else {
  strcpy(fileselected,"");
 }
 wnclose("_fsel_prev");
 wnclose("_fsel");
 return;
}
/*fct fsprevcb */
static void fsprevcb(char *wname,int i,int j) {
 static Windowst *fsprevw;
 FILE *f;
 char ch[200],*cp;
 int prev;
 if (i==1) {
  if (fs_preview) wnclose("_fsel_prev");
  fs_preview=0; return;
 } else if (!fs_preview) {
  char *t[]={""};
  int x=0,y=0,w=120,h=100;
  Windowst *fsw=wfindname(NULL,"_fsel");
  if (fsw) { x=fsw->x; y=fsw->y+fsw->h; w=fsw->w; h=fsw->h; }
  sprintf(ch,"_fsel_prev,%d,%d,%d,%d,brightwhite,nochild",x,y,w,h);
  fsprevw=wclistbox(ch,"",1,t,NULL);
 }
 prev=fs_preview=i;
 if (strcmp(fileselected,"")) {
  char *mo="r";
  if (prev==2 && (f=fopen(fileselected,"rb"))!=NULL) {
   int bin0=0,binz=0,aslf=0,ascr=0;
   for (i=0;i<1000;i++) {
    int c=fgetc(f);
    if (feof(f)) break;
    switch (c) {
     case 0:  bin0++; break;
     case 26: binz++; break;
     case 13: ascr++; break;
     case 10: aslf++; break;
    }
   }
   fclose(f);
   if (bin0>0 || binz>1 || (ascr<i/200 && aslf<i/200)) prev=4;
   else prev=3;
  }
  if (prev==4) mo="rb";
  if ((f=fopen(fileselected,mo))==NULL) {
   strcpy(ch,"Could not open:");
   strcat(ch,fileselected);
   wpboxadd(fsprevw,ch,0);
  } else {
   wpboxdelall(fsprevw);
   switch (prev) {
   case 2: /*auto*/
   case 4: /*hex*/
    for (i=0;i<1000;i++) {
     char *cp=ch,*cpa=ch+38;
     for (j=0;j<16;j++) {
      int c=fgetc(f);
      if (feof(f)) { *cp++=' ';*cp++=' ';c=' '; }
      else {
       *cp++=(c>>4 ) + ((c>>4 )>9 ? 'a'-10 : '0');
       *cp++=(c&0xf) + ((c&0xf)>9 ? 'a'-10 : '0');
      }
      if (j%4==3) *cp++=' ';
      *cpa++= c ? c : ' ';
     }
     *cp++='|'; *cp=' '; *cpa=0;
     wpboxadd(fsprevw,ch,i);
     if (feof(f)) break;
    }
    break;
   case 3: /*asci*/
    for (i=0;i<1000;i++) {
     fgets(ch,199,f);
     if ((cp=strchr(ch,'\n'))!=NULL) *cp=0;
     if (feof(f)) break;
     wpboxadd(fsprevw,ch,i);
    }
    break;
   }
   fclose(f);
  }
  wpdraw(fsprevw);
 }
 return;
}
/*fct fseditcb */
static void fseditcb(char *wename,int i,int j) {
 if (fs_preview) fsprevcb(wename,fs_preview,1);
 return;
}
/*fct wfileselect */
char *wfileselect(char *mask,char *direct,char *title) {
 int i,x=100,y=50,w=385,h=150;
#ifndef XWI
 int ndrives=16;
 char *drives[]={"A:","B:","C:","D:","E:","F:","G:","H:",
                 "I:","J:","K:","L:","M:","N:","O:","P:"};
#endif
 int nprev=4;
 char *pprev[]={"view off","view auto","view ascii","view hex"};
 static int lastdrv=0;
 static char lastdir[200];
 unsigned int currentdrv,nrdrives;
 int nmasks=0;
 const int    mcmask=400, mmasks=10;
 char par[100],cmask[400],*masks[10],currentdir[200],*t="";
 Windowst *lbd;
 fs_preview=0;
 strncpy(cmask,mask,mcmask);
 masks[0]=cmask;
 while (++nmasks<mmasks) {
  char *cp=strstr(masks[nmasks-1],"|");
  if (!cp) break;
  *cp=0;
  masks[nmasks]=cp+1;
 }
 maskextract(filemask,masks[0]);
 strcpy(fileselected,"");
#ifndef XWI
 currentdrv=_getdrive();
 getcwd(currentdir,200);
 _dos_setdrive(currentdrv,&nrdrives); if (nrdrives<ndrives) ndrives=nrdrives;
 if (lastdrv) { _chdrive(lastdrv); chdir(lastdir); }
#else
 getcwd(currentdir,200);
 if (lastdrv) chdir(lastdir);
#endif
 sprintf(par,"_fsel,%d,%d,%d,%d,white,tlarge,nochild",x,y,w,h);
 wcframe(par,title,NULL);
 sprintf(par,"_fsel_e,%d,%d,black",
             x+115,y+7);
 wcedit(par,fileselected,42,fseditcb);
 sprintf(par,"_fsel_f,%d,%d,%d,%d,frthin,brightwhite,tlarge",
             x+15,y+25,130,h-60);
 lbd=wclistbox(par,"Files",1,&t,fsfilecb);
 lbd->mask|=MM_LMBUP;
 sprintf(par,"_fsel_d,%d,%d,%d,%d,frthin,brightwhite,tlarge",
             x+160,y+25,130,h-60);
 lbd=wclistbox(par,"Directories",1,&direct,fsdirecb);
 lbd->mask|=MM_LMBUP;
 sprintf(par,"_fsel_m,%d,%d,%d,%d,frthin,brightwhite,tlarge",
             x+15,y+h-32,130,22);
    wccombobox(par,masks[0],nmasks,masks,fsdirecb);
#ifndef XWI
 sprintf(par,"_fsel_l,%d,%d,%d,%d,frthin,brightwhite,tlarge",
             x+160,y+h-32,130,22);
    wccombobox(par,"Drives",ndrives,drives,fsdirecb);
#endif
 sprintf(par,"_fsel_ok,%d,%d,%d,%d,green,tlarge",
             x+302,y+25,70,22);
 wcbutton(par,"Ok",NULL,fscancb);
 sprintf(par,"_fsel_can,%d,%d,%d,%d,red,tlarge",
             x+302,y+50,70,22);
 wcbutton(par,"Cancel",NULL,fscancb);
 sprintf(par,"_fsel_p,%d,%d,%d,%d,frthin,brightwhite",
             x+302,y+80,70,14);
    wccombobox(par,"View off",nprev,pprev,fsprevcb);
 fsdirecb(lbd->name,1,1);
 do {
  i=wloop();
  switch (i) {
  case 27 : wnclose("_fsel_prev"); wnclose("_fsel"); break;
  }
 } while (i && wfindname(NULL,"_fsel"));
#ifndef XWI
 lastdrv=_getdrive();getcwd(lastdir,200);
 _chdrive(currentdrv);
#else
 lastdrv=1;
 getcwd(lastdir,200);
#endif
 chdir(currentdir);
 return fileselected;
}
/* End    fileselectbox */

#endif /* ! MSW */
