/*#define VGA 1*/
/*#define MSW 1*/
/*#define XWI 1*/
#ifdef __cplusplus
extern "C" {
#endif

typedef void (*Wcallb)(char *name,int ip1,int ip2) ;
typedef void (Wcallbf)(char *name,int ip1,int ip2) ;

#ifdef VHAUPT
 #define EXT
#else
 #define EXT extern
#endif
#ifdef XWI
#define yvermenu 17
#include "xwi.h"
#endif
#ifdef VGA
#define yvermenu 17
#include "vga.h"
#endif
#ifdef MSW
#define yvermenu 0
#include "msw.h"
#endif

enum {_BLACK=0       , _BLUE          , _GREEN         , _CYAN          ,
      _RED           , _MAGENTA       , _BROWN         , _WHITE         ,
      _GRAY          , _LIGHTBLUE     , _LIGHTGREEN    , _LIGHTCYAN     ,
      _LIGHTRED      , _LIGHTMAGENTA  , _YELLOW        , _BRIGHTWHITE  };
#define w_smallfont2 4 /* in drw*/
#define w_largefont2 5 /* in drw*/

struct windowst{ void *next,*child,*ptr,*helptext; char *name; Pixel *save;
   void (*draw)(struct windowst*);int (*hit)(struct windowst*,Evstack *);
                 short x,y,w,h,stat,att,mask;char typ,col; };  /* Windowst;*/
typedef struct windowst Windowst;
typedef struct { Windowst *win; double fa,fe,finc,fcur,flast,fpage,*flist;
                 double *fres;Wcallb callb;}                     Sliderst;
typedef struct { Windowst *win; char *text;
                 int *ires;Wcallb callb;}                        Buttonst;
typedef struct { Windowst *win; char *text; void *data; int cx,cy,cw,ch,ndata;
                           Wcallb callb;}                        Framest;
typedef struct { Windowst *win; char *text; void *data; int cx,cy,cw,ch,ndata,
               hili,rad; Wcallb *cbl;Wcallb callb;}              Liboxst;
typedef struct { Windowst *win; char *text; int n,ic;
                           Wcallb callb; }                       Labelst;


void wresource(char *fn) ;
void wcmessagexy(int x,int y,char *s) ;
void wlayout(char *par,int nr,int dist) ;
void wpclose(Windowst *we) ;
void wnclose(char *name) ;
void wcloseall(void) ;
Windowst * wcmenuadd(char *s,Wcallb *mcb) ;
Windowst * wcmenupopup(char *s,Wcallb *mcb) ;
void wmenupopxy(int x,int y) ;
void wnmenuset(char *name,int row,char *p) ;
Windowst* wclabel(char *par,char *text) ;
Windowst* wcedit(char *par,char *text,int n,Wcallb callb) ;
void wpsettext(Windowst *win,char *ch) ;
void wnsettext(char *name,char *ch) ;
Windowst* wcbutton(char *par,char *text,int *ires,Wcallb callb) ;
void wpbitmap(Windowst *wb,char *bm);
Windowst* wcframe(char *par,char *text,Wcallb callb) ;
Windowst* wcslider(char *par,double *fli /*fa,fe,finc,fincp oder listval*/,
                 double *fres,Wcallb callb) ;
void wpsliderset(Windowst *win,double val) ;
void wnsliderset(char *name,double val) ;
Windowst *wclistbox(char *par,char *text,int ntext,char **ptext,Wcallb callb) ;
Windowst *wccombobox(char *par,char *text,int ntext,char **ptext,Wcallb callb) ;
Windowst *wcradiobox(char *par,char *text,int ntext,int an,char **ptext,Wcallb callb) ;
void wpclip(Windowst *ws) ;
void wpboxadd(Windowst *w,char *text,int line) ;
void wnboxadd(char *name,char *text,int line) ;
void wpboxdel(Windowst *w,int line) ;
void wnboxdel(char *name,int line) ;
void wpboxdelall(Windowst *w) ;
char *wpcombotxt(Windowst *win,int i) ;
void wncomboset(char *name,int val) ;
int wequtxt(char *s1,char *s2) ;
char *wmktext(char *ch) ;
int wpxyinclient(Windowst *frw,int *xp,int *yp) ;
int wloop(void) ;
int wpeek(void) ;
void wpredraw(Windowst *wp) ;
Windowst *wfindname(Windowst *wr,char *name) ;
Windowst *wnfind(char *name) ;
void wpdraw(Windowst *wp) ;
void wndraw(char *name) ;
void wcpaledit(int col,int x,int y) ;
int wgetevmask(void) ;
int wgetevbutton(void) ;
void wpsetstatuswin(Windowst *w) ;
void wsetstatustext(char *t) ;
void wphelptext(Windowst *w,char *t) ;
void wnhelptext(char *n,char *t) ;
void wsetsizecallb(Wcallb cb) ;
int wpsetatt(Windowst *w,char *att) ;
int wnsetatt(char *n,char *att) ;
void wntotop(char *name) ;
void wnsetmodal(char *name) ;

Pixel * drwframe(Windowst *frwp) ;
Pixel * drwframename(char *name) ;
void drwupdate(void) ;
void drwupdatew(Windowst *frw) ;
void drwclose(Windowst *frwp) ;
void drwclear(void) ;
int drwsetmode(int mode) ;
void drwgetwh(int *w,int *h);
void drwgetxy(int *x,int *y);
void drwlinec(int x1,int y1,int x2,int y2,int col) ;
int drwpixel(int x,int y,int col) ;
void drwsetbox(int xp,int yp,int wp,int hp,int col) ;
void drwputbox(int xp,int yp,int wp,int hp,Pixel *p) ;
void drwgetbox(int xp,int yp,int wp,int hp,Pixel *p) ;
void drwzbuf(void) ;
int drwfilledpol(int n,int x[],int y[],Pixel d[],Pixel c[]) ;
void drwlinelc(int x1,int y1,int c1,int x2,int y2,int c2) ;
int drwfont(int n,int color,int bcolor) ;
void drwtext(int x,int y,char *s) ;
void drwprint(int mode) ;
int drwprintini(double spixpmm,double *xpixpmm,double *ypixpmm);

char *wfileselect(char *mask,char *direct,char *title) ;
Pixel * w_readbmp(char *file,int *wp,int *hp,int *maxpalp
              ,unsigned char *palr,unsigned char *palg,unsigned char *palb) ;
Pixel * w_bmpred(Pixel *b0,int wp,int hp) ;
Pixel * w_bmpblow(Pixel *b0,int wp,int hp,int winc) ;
#ifdef __cplusplus
}
#endif
