
#ifdef __cplusplus
extern "C" {
#endif

#ifndef VHAUPT
 #undef EXT
 #define EXT
#endif
#include "krn.h"
typedef unsigned char Pixel;

enum { Cswitchon='',Cswitchoff='',Cmultiswoff='',Cmultiswon='',
       Cinactive='' };
enum {PUTmode=0,XORmode,SNZmode};
#define SNZzero 255
EXT long xwi_rgb[]
#ifdef VHAUPT
  ={0x000000L, 0xa80000L, 0x00a800L, 0xa8a800L, 0x0000a8L, 0xa800a8L,
    0x0054a8L, 0xa8a8a8L, 0xd0d0d0L, 0xff5454L, 0x54ff54L, 0xffff54L,
    0x5454ffL, 0xff54ffL, 0x54ffffL, 0xffffffL}
#endif
                                ;
enum {xwi_smallfont=1,xwi_6x8font=1,xwi_8x8font=2,xwi_8x14font=3
 ,xwi_largefont=3 };
EXT int text_fg,text_bg,DRWmode,TXTDRWmode;
EXT unsigned int xclip0,yclip0,xclip1,yclip1,xclipa,yclipa;
EXT int xwi_mx,xwi_my,xwi_cursor;

#define w_mx xwi_mx
#define w_my xwi_my
#define w_mediofont xwi_8x8font
#define w_smallfont xwi_6x8font
#define w_largefont xwi_8x14font
#define w_movewin xwi_movewin
#define w_setmode xwi_setmode
#define w_getmode xwi_getmode
#define w_setcur xwi_setcur
#define w_setclip(on) xwi_setclip(on)
#define w_init xwi_init
#define w_enit xwi_enit
#define w_selectcur xwi_selectcur
#define w_drawpixel(x,y,c) xwi_drawpixel((x),(y)+yvermenu,(c))
#define w_readpixel(x,y,c) xwi_readpixel((x),(y)+yvermenu,(c))
#define w_putbox(x,y,w,h,p) xwi_putbox((x),(y)+yvermenu,(w),(h),(p))
#define w_getbox(x,y,w,h,p) xwi_getbox((x),(y)+yvermenu,(w),(h),(p))
#define w_rect(x,y,u,v,p) xwi_rect((x),(y)+yvermenu,(u),(v)+yvermenu,(p))
#define w_fillrect(x,y,u,v,p) xwi_fillrect((x),(y)+yvermenu,(u),(v)+yvermenu,(p))
#define w_horli(y,x,v,p) xwi_horli((y)+yvermenu,(x),(v),(p))
#define w_drawline(x,y,u,v,p) xwi_drawline((x),(y)+yvermenu,(u),(v)+yvermenu,(p))
#define w_font xwi_font
#define w_text(x,y,s) xwi_text((x),(y)+yvermenu,(s))
#define w_getmes xwi_getmes
#define w_wartsync xwi_wartsync
#define w_getpal xwi_getpal
#define w_setpal xwi_setpal

#define xwi_setmode(m)   DRWmode=(m);
#define xwi_getmode()    DRWmode
#define xwi_setcur(on)   if (xwi_cursor!=(on)){xwi_cursor=(on);}
void xwi_init(void);
void xwi_enit(void);
void xwi_movewin(int x,int y,int w,int h);
void xwi_selectcur(int n) ;
void xwi_drawpixel(unsigned int x,unsigned int y,Pixel c) ;
Pixel xwi_readpixel(unsigned int x,unsigned int y) ;
void xwi_putzei(int y,int x,int n,Pixel *c) ;
void xwi_getzei(int y,int x,int n,Pixel *c) ;
void xwi_putbox(int x,int y,int w,int h,Pixel *pix) ;
void xwi_getbox(int x,int y,int w,int h,Pixel *pix) ;
void xwi_alleszu(Pixel c) ;
void xwi_rect(int x1,int y1,int x2,int y2,int f) ;
void xwi_fillrect(int x1,int y1,int x2,int y2,int f) ;
void xwi_horli(int y,int x1,int x2,Pixel c) ;
void xwi_drawline(int x1, int y1, int x2, int y2,Pixel c) ;
void xwi_drawlinb(int x1, int y1, int x2, int y2,Pixel c) ;
int xwi_font(int n,int color,int bcolor) ;
void xwi_text(int x,int y,char *s) ;
void xwi_drwcur(void) ;
int xwi_getmes(Evstack *ev,int warte) ;
void xwi_wartsync(int n);
void xwi_setpal(int ix,int red,int green,int blue) ;
void xwi_getpal(int ix,int *red,int *green,int *blue) ;
void xwi_setallpal(unsigned char *rgb) ;
void xwi_getallpal(unsigned char *rgb) ;
#ifdef __cplusplus
};
#endif
