/* Converts Windoof bmp to wirp bitmap
 bmp2wpm fileout file1.bmp ...
         fileout   Output file in c synatx
         file1.bmp Input file in bmp format
 */
#include <stdio.h>
#include <string.h>
#include <dos.h>
#define VHAUPT
#include "wirp.h"

void main(int argc,char **argv) {
 int i,w,h,n,x,y,maxpalp=16;
 Pixel *bm,*b;
 char *cp,name[32];
 FILE *fo;
 EXPAND_WILDCARDS
 if (argc<3)
   { printf("Usage: bmp2wpm fileout.wpm filein1.bmp ...\n"); exit(1); }
 if ((fo=fopen(argv[1],"w"))==NULL)
   { printf("Cannot open %s\n",argv[1]); exit(1); }
 for (i=2;i<argc;i++) {
  bm= w_readbmp(argv[i],&w,&h,&maxpalp,NULL,NULL,NULL);
  if (!bm) printf("Cannot convert %s\n",argv[i]);
  else {
   b=bm;
   n=strlen(argv[i]);
   cp=argv[i]+n-1;
   while (cp>argv[i]) {
    if (*cp==':'||*cp=='\\'||*cp=='/') { cp++; break; }
    cp--;
   }
   strcpy(name,cp);
   if ((cp=strchr(name,'.'))!=NULL) *cp=0;
   fprintf(fo,"#define %s_wh \"%d,%d\"\n",name,w,h);
   fprintf(fo,"static char %s[] = {",name);
   for (y=0;y<h;y++) {
    fprintf(fo,"\n  \"");
    for (x=0;x<w;x++) fprintf(fo,"%x",*b++);
    fprintf(fo,"\"");
   }
   fprintf(fo,"};\n");
  }
 }
}

