#ifdef VHAUPT
 #undef EXT
 #define EXT
#else
 #undef EXT
 #define EXT extern
#endif
/* wirp kernle (mouse etc.) defines 961018/ak */
/* Mouse mask
;       Bit 0:  mouse moved
;               Bit 1:  left button is pressed
;               Bit 2:  left button is released
;               Bit 3:  right button is pressed
;               Bit 4:  right button is released
;               Bit 5:  middle button is pressed
;               Bit 6:  middle button is released
 */
enum { MM_MOVE=1,MM_LMBDOWN=2,MM_LMBUP=4,MM_RMBDOWN=8,MM_RMBUP=16,
                 MM_MMBDOWN=32,MM_MMBUP=64,
       key_mask=128,tim_mask=256,
       leave_mask=512,size_mask=1024,paint_mask=2048,close_mask=4096,
       menu_mask=8192,menuselect_mask=16384};
/* button if key:  (shift<<16) + (scan<<8) + ascii
          if mouse:(shift<<8) + 1+2+4 (left/right/middle button down)
   shift:
     0x01       Right shift key is down
                        0x02    Left shift key is down
                        0x04    Ctrl key is down
                        0x08    Alt key is down
                        0x10    Scroll Lock is toggled
                        0x20    Num Lock is toggled
                        0x40    Caps Lock is toggled
                        0x80    Ins is toggled
        */
enum { LMB_DOWN=1,RMB_DOWN=2,MMB_DOWN=4,
       KEY_RSH=256,KEY_LSH=512,KEY_CTRL=1024,KEY_ALT=2048};

enum scancodes { key_F1=359,key_home=371,key_up,key_pgup,key_left=375,
       key_right=377,key_end=379,key_down,key_pgdn,key_ins,key_del }; /*+300*/


#define Mevs 200
EXT int nevs,levs;
typedef struct { unsigned short mask,buttn; short x,y; } Evstack;
EXT Evstack evstack[Mevs];
#if !defined(_WINDOWS) && !defined(XWI)
 #ifndef __WATCOMC__
 void __cdecl msm_handler(unsigned mask,unsigned buttn,unsigned x,unsigned y);
 #else
 void _loadds far msm_handler(unsigned mask,unsigned buttn,unsigned x,unsigned y);
 #endif
#endif
