#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include <time.h>
#ifndef __WATCOMC__
#include <msmouse.h>
#define VIDEOSP 0a0000h
#else
 const unsigned int VIDEOSP=0xa0000;
#endif
#include "vga.h"


#define SEG_SELECT 0x3CD
#define BANKLG  65536
#define BANKSH  16
#define npix (vga_mx*vga_my)
#define nseg ((npix>>16)+1)
#define    vga_offset(linear)  ( (linear)&(BANKLG-1) )
#define    vga_bank(linear)    ( (linear)>>BANKSH )


static unsigned int akt_bank = 0;
static int m_x=10,m_y=10,m_k=0,indrwcur=0;

#define msmstks 2000
static char msm_stack[msmstks+100];
#ifndef __WATCOMC__
void __cdecl msm_handler(unsigned mask,unsigned buttn,unsigned x,unsigned y) {
#else
extern void vga_es2ds(void);
#pragma aux vga_es2ds= \
      "push es" \
      "push ds" \
      "pop es" ;
extern void vga_reses(void);
#pragma aux vga_reses= \
      "pop es" ;
#pragma off (check_stack)
void _loadds far msm_handler(unsigned mask,unsigned buttn,unsigned x,unsigned y) {
#pragma aux msm_handler parm [eax] [ebx] [ecx] [edx]
#endif
 Evstack *ev;
 int k,s,nev=nevs;
 static int aktiv=0,sletzt=0;
 if (aktiv) return;
 aktiv=1;
#ifdef __WATCOMC__
 vga_es2ds();
#endif
/*
 while (_bios_keybrd(1)) {
  k=_bios_keybrd(0);  // (scan<<8) + ascii
  s=_bios_keybrd(2);
  if (++nev == Mevs) nev=0;
  if (nev != levs) {
   ev=evstack+nev;
   ev->mask=key_mask;ev->buttn=k+(s<<16);ev->x=m_x;ev->y=m_y;
   nevs=nev;
  }
 }
        */
 if (mask) {
  m_x=x;m_y=y;m_k=buttn;
  if (!indrwcur) vga_drwcur();
  if (++nev == Mevs) nev=0;
  if (nev != levs) {
    if (!indrwcur) s=_bios_keybrd(2);
    else           s=sletzt;
    sletzt=s;
    ev=evstack+nev;
    ev->mask=mask;ev->buttn=buttn+(s<<8);ev->x=x;ev->y=y;
    nevs=nev;
  }
 }
#ifdef __WATCOMC__
 vga_reses();
#endif
 aktiv=0;
}
#ifdef __WATCOMC__
 int msm_init() {
  union REGS reg;
  reg.w.ax=0;
  int386(51,&reg,&reg);
  if (reg.w.ax != 65535) return 0;
  else return -1;
 }
 msm_term() {  
  struct SREGS sregs;
  union REGS reg;
  int (far *fctptr)();
  segread(&sregs);
  fctptr=NULL;
  reg.x.edx=FP_OFF(fctptr);
  sregs.es= FP_SEG(fctptr);
  reg.w.cx=0;
  reg.w.ax=12;
  int386x(51,&reg,&reg,&sregs);
  msm_init();
 }
 msm_setareax(int min,int max) { 
  union REGS reg;
  reg.w.ax=7; reg.w.cx=min; reg.w.dx=max; int386(51,&reg,&reg);
 }
 msm_setareay(int min,int max) {
  union REGS reg;
  reg.w.ax=8; reg.w.cx=min; reg.w.dx=max; int386(51,&reg,&reg);
 }
 msm_signal(int mask,
  void (_loadds far *f)(unsigned,unsigned,unsigned,unsigned),void *stk) {
  struct SREGS sregs;
  union REGS reg;
  int (far *fctptr)();
  segread(&sregs);
  fctptr=msm_handler;
  reg.x.edx=FP_OFF(fctptr);
  sregs.es= FP_SEG(fctptr);
  reg.w.cx=mask;
  reg.w.ax=12;
  int386x(51,&reg,&reg,&sregs);
 }
 msm_setcurpos(int x,int y) {};
void msleep(int n) {
 vga_wartsync(n/20+1);
}
//#pragma on (check_stack)
#endif

const int curbms=16;
static unsigned char *curbm=NULL;
static int curoff=0;
#define x  0
#define r 13
#define o SNZzero
//#define x 15
//#define o 0
static unsigned char curpfeillo[256]= {
    x,x,x,x,x,x,x,x,x,o,o,o,o,o,o,o,
    x,r,r,r,r,r,x,x,o,o,o,o,o,o,o,o,
    x,r,r,r,r,x,x,o,o,o,o,o,o,o,o,o,
    x,r,r,r,r,x,x,o,o,o,o,o,o,o,o,o,
    x,r,r,r,r,r,x,x,o,o,o,o,o,o,o,o,
    x,r,x,x,r,r,r,x,x,o,o,o,o,o,o,o,
    x,x,x,x,x,r,r,r,x,x,o,o,o,o,o,o,
    x,x,o,o,x,x,r,r,r,x,x,o,o,o,o,o,
    x,o,o,o,o,x,x,r,r,r,x,x,o,o,o,o,
    o,o,o,o,o,o,x,x,r,r,r,x,x,o,o,o,
    o,o,o,o,o,o,o,x,x,r,r,r,x,x,o,o,
    o,o,o,o,o,o,o,o,x,x,r,r,r,x,x,o,
    o,o,o,o,o,o,o,o,o,x,x,r,r,r,x,x,
    o,o,o,o,o,o,o,o,o,o,x,x,r,x,x,o,
    o,o,o,o,o,o,o,o,o,o,o,x,x,x,o,o,
    o,o,o,o,o,o,o,o,o,o,o,o,x,o,o,o};
static unsigned char curkreuz[256]= {
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    x,x,x,x,x,x,x,r,x,x,x,x,x,x,x,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,x,o,o,o,o,o,o,o,o,
    o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o};
#undef x
#undef r
#undef o

void vga_drwcur(void) {
 static int xl=-1,yl=-1;
 static unsigned char unter[256];
 const int farbe=15,m=8;
 int moved=xl!=m_x||yl!=m_y;
 int on=vga_cursor;
 static unsigned short clipsv,csx0,csy0,csx1,csy1,csxa,csya;
 clipsv=0;
 if (indrwcur) return;
 indrwcur++;
 if (xl!=-1 && (moved|| !on)) {
  clipsv=1;
  csx0=xclip0;csy0=yclip0;csx1=xclip1;csy1=yclip1;csxa=xclipa;csya=yclipa;
  xclip0=0,yclip0=0,xclip1=vga_mx-1,yclip1=vga_my-1,xclipa=vga_mx,yclipa=vga_my;
  vga_putbox(xl+curoff,yl+curoff,curbms,curbms,unter);
  xl=-1;
 }
 if (moved && on) {
  int modes=vga_getmode();
  xl=m_x;yl=m_y;
  if (!clipsv) { clipsv=1;
   csx0=xclip0;csy0=yclip0;csx1=xclip1;csy1=yclip1;csxa=xclipa;csya=yclipa;
   xclip0=0,yclip0=0,xclip1=vga_mx-1,yclip1=vga_my-1,xclipa=vga_mx,yclipa=vga_my;
  }
  vga_getbox(xl+curoff,yl+curoff,curbms,curbms,unter);
  vga_setmode(SNZmode);
  vga_putbox(xl+curoff,yl+curoff,curbms,curbms,curbm);
  vga_setmode(modes);
 }
 if (clipsv) {
   xclip0=csx0;yclip0=csy0;xclip1=csx1;yclip1=csy1;xclipa=csxa;yclipa=csya;
 }
 indrwcur--;
}

/*
static void et4000_setz(int bank) {
 // Set both read and write bank.
 char c;
 if (akt_bank!=bank) {
  akt_bank=bank;
  outp(SEG_SELECT, bank | (bank << 4));
 // if (et4000_chiptype >= CHIP_ET4000W32i) {
  // Write page4-5 to bits 0-1 of ext. bank register,
  // and to bits 4-5.
 //  outb(0x3cb, (inb(0x3cb) & ~0x33) | (bank >> 4) | (bank & 0x30));
 // }
 }
}
 */
/* #if VGAMODE<0x100 */
/*
#define vga_setz(bank) if (akt_bank!=(bank)) { \
                           akt_bank=(bank); \
                           outp(SEG_SELECT,(bank)|((bank)<<4)); } */
static void vga_setz_et4(unsigned int bank) {
                       if (akt_bank!=(bank)) { \
                           akt_bank=(bank); \
                           outp(SEG_SELECT,(bank)|((bank)<<4)); }
}
/* #else  VESA */ 
/*fct vga_setz*/
static void vga_setz_vesa(unsigned int bank) {
 union _REGS reg;
// int ok;
 if (akt_bank!=bank) {
  akt_bank=bank;
  indrwcur++;
 #ifndef __WATCOMC__
   reg.x.ax=0x4f05;
   reg.x.bx=0;
   reg.x.dx=bank;
   int86(0x10,&reg,&reg);
   reg.x.ax=0x4f05;
   reg.x.bx=1;
   reg.x.dx=bank;
   int86(0x10,&reg,&reg);
//  ok=reg.x.ax==0x4f00;
 #else
   reg.x.eax=0x4f05;
   reg.x.ebx=0;
   reg.x.edx=bank;
   int386(0x10,&reg,&reg);
   reg.x.eax=0x4f05;
   reg.x.ebx=1;
   reg.x.edx=bank;
   int386(0x10,&reg,&reg);
//  ok=(reg.x.eax&0xffff)==0x4f00;
 #endif
  indrwcur--;
 }
}
/* #endif */

static void (*vga_setz)(unsigned int bank);
/*fct vga_init*/
void vga_init(void) {
 union _REGS reg;
 int ok,vgam,n;
 long l;
 vga_nb=1; /* 24 bit modes n.i. */
/* #if VGAMODE>=0x100 */
/* VESA */
  vga_setz=vga_setz_vesa;
 #ifndef __WATCOMC__
  switch (vga_my) {
  case 600: vga_mx=800; vgam=VESA_600_8;break;
  case 768: vga_mx=1024;vgam=VESA_768_8;break;
  case 1024:vga_mx=1280;vgam=VESA_1024_8;break;
  case 480:
  default:  vga_my=480;
            vga_mx=640; vgam=VESA_480_8;break;
  }
  reg.x.ax=0x4f02;
  reg.x.bx=vgam;
  int86(0x10,&reg,&reg);
  ok=reg.x.ax==0x004f;
 #else
  reg.x.eax=0x4f02;
  reg.x.ebx=vgam;
  int386(0x10,&reg,&reg);
  ok=(reg.x.eax&0xffff)==0x004f;
 #endif
/* #else */
 if (!ok) {
  switch (vga_my) {
  case 600: vga_mx=800; vgam=ET4_600;break;
  case 768: vga_mx=1024;vgam=ET4_768;break;
  case 480:
  default:  vga_my=480;
            vga_mx=640; vgam=ET4_480;break;
  }
 #ifndef __WATCOMC__
  reg.x.ax=vgam;
  int86(0x10,&reg,&reg);
  ok=reg.x.ax!=vgam;
 #else
  reg.x.eax=vgam;
  int386(0x10,&reg,&reg);
  ok=(reg.x.eax&0xffff)!=vgam;
 #endif
  if (ok) vga_setz=vga_setz_et4;
 }
/* #endif */
 if (!ok) { puts("Cannot switch to VGAmode!\n"); exit(1); }
 text_fg=7,text_bg=SNZzero,DRWmode=PUTmode,TXTDRWmode=SNZmode;
 xclip0=0,yclip0=0,xclip1=vga_mx-1,yclip1=vga_my-1,xclipa=vga_mx,yclipa=vga_my;
 vga_cursor=1;vga_selectcur(1);
 if (msm_init()!=-1) { vga_enit(); puts("No mouse!\n"); exit(1); }
 msm_setareax(0,vga_mx-1);
 msm_setareay(0,vga_my-1);
 msm_setcurpos(10,10);
 msm_signal(0x7f,msm_handler,msm_stack+msmstks);
 atexit(vga_enit);
 for (n=0;n<16;n++) {
  l=vga_rgb[n];
  vga_setpal(n,(l<<2)&0xff,(l>>6)&0xff,(l>>14)&0xff);
 }
 for (n=16;n<80;n++) {
  l=(n-16)*4;
  vga_setpal(n,l,l,l);
 }
}
/*fct vga_enit*/
void vga_enit(void) {
 union _REGS reg;
 atexit(NULL);
 msm_term();
#ifndef __WATCOMC__
 reg.x.ax=3;
 int86(0x10,&reg,&reg);
#else
 reg.x.eax=3;
 int386(0x10,&reg,&reg);
#endif
}
/*fct vga_selectcur*/
void vga_selectcur(int n) {
 vga_setcur(0);
 switch (n) {
 case 1: curbm=curpfeillo;curoff=0;  break;
 case 2: curbm=curkreuz;  curoff=-7; break;
 }
 vga_setcur(1);
}

#ifndef __WATCOMC__
/*fct vga_pixelb*/
static void vga_pixelb(unsigned int off,Pixel c) {
 asm {
      mov es,_x386_zero_base_selector
      mov eax,off
      mov bh,c
      mov byte ptr es:VIDEOSP[eax],bh
 }
}
#else
extern void vga_pixelb(unsigned int off,Pixel c);
#pragma aux vga_pixelb= \
      "add eax,VIDEOSP" \
      "mov byte ptr [eax],bh" \
       parm [eax] [bh];
extern void vga_pixelx(unsigned int off,Pixel c);
#pragma aux vga_pixelx= \
      "add eax,VIDEOSP" \
      "xor byte ptr [eax],bh" \
       parm [eax] [bh];
extern unsigned char vga_pixelr(unsigned int off);
#pragma aux vga_pixelr= \
      "add eax,VIDEOSP" \
      "mov byte ptr al,[eax]" \
       parm [eax] \
       value [al];
extern void vga_pixelsl(unsigned int off,unsigned int i,unsigned int cccc);
#pragma aux vga_pixelsl= \
      "add edi,VIDEOSP" \
      "rep stosd" \
       parm [edi] [ecx] [eax] \
       modify [edi ecx];
extern void vga_pixelsb(unsigned int off,unsigned int i,Pixel c);
#pragma aux vga_pixelsb= \
      "add edi,VIDEOSP" \
      "rep stosb" \
       parm [edi] [ecx] [al] \
       modify [edi ecx];
extern void vga_pixelml(unsigned int off,unsigned int i,unsigned int *c);
#pragma aux vga_pixelml= \
      "add edi,VIDEOSP" \
      "rep movsd" \
       parm [edi] [ecx] [esi] \
       modify [edi ecx esi];
extern void vga_pixelmb(unsigned int off,unsigned int i,Pixel *c);
#pragma aux vga_pixelmb= \
      "add edi,VIDEOSP" \
      "rep movsb" \
       parm [edi] [ecx] [esi] \
       modify [esi edi ecx];
#endif
void vga_drawpixel(unsigned int x,unsigned int y,Pixel c) {
 int seg,off,l;
 if (x>=xclipa || y>=yclipa) return;
 l=vga_linear(x+xclip0,y+yclip0);
 seg=vga_bank(l);
 off=vga_offset(l);
 vga_setz(seg);
 switch (DRWmode) {
 case XORmode:
#ifndef __WATCOMC__
  asm {
      mov es,_x386_zero_base_selector
      mov eax,off
      mov bh,c
      xor byte ptr es:VIDEOSP[eax],bh
  }
#else
  vga_pixelx(off,c);
#endif
  break;
 case SNZmode:
  if (c==SNZzero) break;
 case PUTmode:
#ifndef __WATCOMC__
  asm {
      mov es,_x386_zero_base_selector
      mov eax,off
      mov bh,c
      mov byte ptr es:VIDEOSP[eax],bh
  }
#else
  vga_pixelb(off,c);
#endif
 }
}
/*fct vga_readpixel*/
Pixel vga_readpixel(unsigned int x,unsigned int y) {
 int seg,off,l;
 Pixel c;
 if (x>=xclipa || y>=yclipa) return 0;
 l=vga_linear(x+xclip0,y+yclip0);
 seg=vga_bank(l);
 off=vga_offset(l);
 vga_setz(seg);
#ifndef __WATCOMC__
 asm {
      mov es,_x386_zero_base_selector
      mov eax,off
      mov byte ptr bh,es:VIDEOSP[eax]
      mov c,bh
 }
 return c;
#else
 return vga_pixelr(off);
#endif
}
/*fct vga_putbox*/
void vga_putbox(int x,int y,int w,int h,Pixel *pix) {
 int i,j;
 for (i=y;i<y+h;i++) {
  vga_putzei(i,x,w,pix);
  pix+=w;
 }
// for (j=x;j<x+w;j++)
//  vga_drawpixel(j,i,*pix++);
} 
/*fct vga_getbox*/
void vga_getbox(int x,int y,int w,int h,Pixel *pix) {
 int i,j;
 for (i=y;i<y+h;i++) {
  vga_getzei(i,x,w,pix);
  pix+=w;
 }
 /*for (j=x;j<x+w;j++)
  *pix++ = vga_readpixel(j,i);*/
} 
/*fct vga_alleszu*/
void vga_alleszu(Pixel c) {
 int i,seg,cccc;
 cccc=c|(c<<8)|(c<<16)|(c<<24);
 for (seg=0;seg<nseg;seg++) {
  vga_setz(seg);
  i=(seg==nseg?(npix&0xffff):65536)/4;
#ifndef __WATCOMC__
  asm {
      mov es,_x386_zero_base_selector
      mov ecx,i
      mov eax,cccc
      mov edi,VIDEOSP
      rep stosd
  }
#else
                vga_pixelsl(0,i,cccc);
#endif
 }
}
/*fct vga_horlib*/
static void vga_horlib(int off,int n,Pixel c) {
 if (n>19) {
  int cccc,m=off&3;
  cccc=c|(c<<8)|(c<<16)|(c<<24);
  if (m) {
   m=4-m;
   vga_horlib(off,m,c);
   off+=m; n-=m;
  }
  m=n>>2;
#ifndef __WATCOMC__
  asm {
      mov edi,VIDEOSP
      add edi,off
      mov es,_x386_zero_base_selector
      mov ecx,m
      mov eax,cccc
      rep stosd
  }
#else
                vga_pixelsl(off,m,cccc);
#endif
  off+=(m<<2); n=n&3;
 }
#ifndef __WATCOMC__
 asm {
      mov edi,VIDEOSP
      add edi,off
      mov es,_x386_zero_base_selector
      mov ecx,n
      mov al,c
      rep stosb
 }
#else
                vga_pixelsb(off,n,c);
#endif
}
/*fct vga_horli*/
void vga_horli(int y,int x1,int x2,Pixel c) {
 int seg,off,n=x2-x1+1,lin;
 if (DRWmode!=PUTmode) vga_drawline(x1,y,x2,y,c);
 else {
  if (n<0) { register int i=x1;x1=x2;x2=i; n=-n; }
  if ((unsigned)y>=yclipa || x2<0) return;
  if (x1<0) x1=0;
  if (x2>=xclipa) x2=xclipa-1;
  if ((n=x2-x1+1)<=0)      return;
  lin=vga_linear(x1+xclip0,y+yclip0);
  seg=vga_bank(lin);off=vga_offset(lin);
  vga_setz(seg);
  if (off+n>BANKLG) {
   vga_horlib(off,BANKLG-off,c);
   n-=BANKLG-off;
   vga_setz(seg+1);
   off=0;
  }
  vga_horlib(off,n,c);
 }
}
/*fct vga_putzeib*/
static void vga_putzeib(int off,int n,Pixel *c) {
 switch (DRWmode) {
 case PUTmode:
#ifndef __WATCOMC__
  asm {
      mov edi,VIDEOSP
      add edi,off
      mov es,_x386_zero_base_selector
      mov ecx,n
      mov esi,c
      rep movsb
  }
#else
                vga_pixelmb(off,n,c);
#endif
  break;
 case XORmode:
#ifndef __WATCOMC__
  asm {
      mov edi,VIDEOSP
      add edi,off
      mov es,_x386_zero_base_selector
      mov ecx,n
      mov esi,c
   loop0:
      mov ah,[esi]
      xor es:[edi],ah
      inc esi
      inc edi
      loop loop0
  }
#else
{
extern void vga_pixellx(unsigned int off,int n,Pixel *c);
#pragma aux vga_pixellx= \
      "add edi,VIDEOSP" \
   "loop0:" \
      "mov ah,[esi]" \
      "xor [edi],ah" \
      "inc esi" \
      "inc edi" \
      "loop loop0" \
                                                parm [edi] [ecx] [esi] \
                                                modify [edi esi ecx ah];
   vga_pixellx(off,n,c);
}
#endif
  break;
 case SNZmode:
#ifndef __WATCOMC__
  asm {
      mov edi,VIDEOSP
      add edi,off
      mov es,_x386_zero_base_selector
      mov ecx,n
      mov esi,c
   loop1:
      mov ah,[esi]
      cmp ah,SNZzero
      je  skip
      mov es:[edi],ah
   skip:
      inc esi
      inc edi
      loop loop1
  }
#else
{
extern void vga_pixellz(unsigned int off,int n,Pixel *c);
const unsigned char SNZz=SNZzero;
#pragma aux vga_pixellz= \
      "add edi,VIDEOSP" \
   "loop0:" \
      "mov ah,[esi]" \
      "cmp ah,SNZz" \
      "je  skip" \
      "mov [edi],ah" \
   "skip:" \
      "inc esi" \
      "inc edi" \
      "loop loop0" \
                                                parm [edi] [ecx] [esi] \
                                                modify [edi esi ecx ah];
   vga_pixellz(off,n,c);
}
#endif
  break;
 }
}
/*fct vga_putzei*/
void vga_putzei(int y,int x1,int n,Pixel *c) {
 int seg,off,lin,x2=x1+n-1;
 if ((unsigned)y>=yclipa || x2<0) return;
 if (x1<0) { c-=x1; x1=0; }
 if (x2>=xclipa) x2=xclipa-1;
 if ((n=x2-x1+1)<=0)      return;
 lin=vga_linear(x1+xclip0,y+yclip0);
 seg=vga_bank(lin);off=vga_offset(lin);
 vga_setz(seg);
 if (off+n>BANKLG) {
  vga_putzeib(off,BANKLG-off,c);
  n-=BANKLG-off;
  c+=BANKLG-off;
  vga_setz(seg+1);
  off=0;
 }
 vga_putzeib(off,n,c);
}
#ifndef __WATCOMC__
/*fct vga_getzeib*/
static void vga_getzeib(int off,int n,Pixel *c) {
  asm {
      mov ecx,n
      mov edi,c
      mov esi,VIDEOSP
      add esi,off
      push ds
      mov ds,_x386_zero_base_selector
      pop es
      push es
      rep movsb
      pop ds
  }
}
#else
extern void vga_getzeib(int off,int n,Pixel *c) ;
#pragma aux vga_getzeib= \
      "add esi,VIDEOSP" \
      "rep movsb" \
                                                parm [esi] [ecx] [edi] \
                                                modify [edi ecx esi];
#endif
/*fct vga_getzei*/
void vga_getzei(int y,int x1,int n,Pixel *c) {
 int seg,off,lin,x2=x1+n-1;
 if ((unsigned)y>=yclipa || x2<0) return;
 if (x1<0) x1=0;
 if (x2>=xclipa) x2=xclipa-1;
 if ((n=x2-x1+1)<=0)      return;
 lin=vga_linear(x1+xclip0,y+yclip0);
 seg=vga_bank(lin);off=vga_offset(lin);
 vga_setz(seg);
 if (off+n>BANKLG) {
  vga_getzeib(off,BANKLG-off,c);
  n-=BANKLG-off;
  c+=BANKLG-off;
  vga_setz(seg+1);
  off=0;
 }
 vga_getzeib(off,n,c);
}

#define ABS(a) (((a)<0) ? -(a) : (a))

/*fct vga_drawline*/
void vga_drawline(int x1, int y1, int x2, int y2,Pixel c)
{
    int dx = x2 - x1;
    int dy = y2 - y1;
    int ax = ABS(dx) << 1;
    int ay = ABS(dy) << 1;
    int sx = (dx >= 0) ? 1 : -1;
    int sy = (dy >= 0) ? 1 : -1;
    int x  = x1;
    int y  = y1;
    if (ax > ay) {
        int d = ay - (ax >> 1);
        while (x != x2) {
            vga_drawpixel(x, y, c);
            if (d > 0 || (d == 0 && sx == 1)) {
                y += sy;
                d -= ax;
            }
            x += sx;
            d += ay;
        }
    } else {
        int d = ax - (ay >> 1);
        while (y != y2) {
            vga_drawpixel(x, y, c);
            if (d > 0 || (d == 0 && sy == 1)) {
                x += sx;
                d -= ay;
            }
            y += sy;
            d += ax;
        }
    }
    vga_drawpixel(x, y, c);
}

/*fct vga_drawlinb*/
void vga_drawlinb(int x1, int y1, int x2, int y2,Pixel c) {
 int seg,off,l;
 l=vga_linear(x1+xclip0,y1+yclip0);
 seg=vga_bank(l);
 off=vga_offset(l);
 l=vga_linear(x2+xclip0,y2+yclip0);
 if (vga_bank(l)!=seg) {
    vga_drawline(x1,y1,x2,y2,c);
    return;
 }
 vga_setz(seg);
 { 
    int dx = x2 - x1;
    int dy = y2 - y1;
    int axx,sx,sy,oy,ay;
    if (dx >= 0) {        sx=1; axx=dx<<1;   }
    else         {        sx=-1;axx=(-dx)<<1;}
    if (dy >= 0) { oy=vga_mx; sy=1; ay =dy<<1;   }
    else         { oy=-vga_mx;sy=-1;ay =(-dy)<<1;}
#ifndef __WATCOMC__
 asm {
      mov es,_x386_zero_base_selector
 }
#else
#endif
    if (axx> ay) {
 /* Register: bh=c, ecx=d, edx=off, esi=x, edi=ay, eax=sx */
#ifndef __WATCOMC__
 asm {
      mov bh,(char)c
      mov edx,off
      mov esi,x1
      mov edi,ay
//        int d = ay - (axx>> 1);
      mov ecx,edi
      mov eax,axx
      shr eax,1
      sub ecx,eax
      mov eax,sx
//        while (x1 != x2) {
loople:
      cmp esi,x2
      je  fertig
//            vga_pixelb(off, c);
       mov byte ptr es:VIDEOSP[edx],bh
//            if (d > 0 || (d == 0 && sx == 1)) {
       cmp ecx,0
       jl  skip1
       jg  skip
       cmp eax,0
       jl  skip1
skip:  
//                off+=oy;
        add edx,oy
//                d -= ax;
        sub ecx,axx
skip1:
//            }
//            x1 += sx; off+=sx;
       add esi,eax
       add edx,eax
//            d += ay;
       add ecx,ay
//     }
       jmp loople
fertig:
     }
#else
extern void vga_drawxx(Pixel c,int off,int x1,int ay,int axx);
 /* Register: bh=c, ecx=d, edx=off, esi=x, edi=ay, eax=sx */
#pragma aux vga_drawxx= \
      "mov ecx,edi" \
      "shr eax,1" \
      "sub ecx,eax" \
      "mov eax,sx" \
"loople:" \
      "cmp esi,x2" \
      "je  fertig" \
       "mov byte ptr VIDEOSP[edx],bh" \
       "cmp ecx,0" \
       "jl  skip1" \
       "jg  skip" \
       "cmp eax,0" \
       "jl  skip1" \
"skip:  " \
        "add edx,oy" \
        "sub ecx,axx" \
"skip1:" \
       "add esi,eax" \
       "add edx,eax" \
       "add ecx,ay" \
       "jmp loople" \
"fertig:" \
       "mov byte ptr VIDEOSP[edx],bh" \
                                                parm [bh] [edx] [esi] [edi] [eax] \
                                                modify [ecx edx esi edi eax] ;
 /* Register: bh=c, ecx=d, edx=off, esi=x, edi=ay, eax=sx */
  vga_drawxx(c,off,x1,ay,axx);
#endif
/*
        while (x1 != x2) {
            vga_pixelb(off, c);
            if (d > 0 || (d == 0 && sx == 1)) {
                y1 += sy; off+=oy;
                d -= axx;
            }
            x1 += sx; off+=sx;
            d += ay;
        }
 */
    } else {
 /* Register: bh=c, ecx=d, edx=off, esi=y1, edi=ay, eax=sy */
#ifndef __WATCOMC__
 asm {
      mov bh,(char)c
      mov edx,off
      mov esi,y1
      mov edi,ay
//        int d = axx- (ay >> 1);
      mov ecx,axx
      mov eax,edi
      shr eax,1
      sub ecx,eax
      mov eax,sy
//        while (y1 != y2) {
loople2:
      cmp esi,y2
      je  fertig2
//            vga_pixelb(off, c);
       mov byte ptr es:VIDEOSP[edx],bh
//            if (d > 0 || (d == 0 && sy == 1)) {
       cmp ecx,0
       jl  skip12
       jg  skip2
       cmp eax,0
       jl  skip12
skip2:
//                off+=sx;
        add edx,sx
//                d -= ay;
        sub ecx,edi
skip12:
//            }
//            y1 += sy; off+=oy;
       add esi,eax
       add edx,oy
//            d += axx;
       add ecx,axx
//      }
       jmp loople2
fertig2:
     }
#else
extern void vga_drawyy(Pixel c,int axx,int off,int y1,int ay);
 /* Register: bh=c, ecx=axx, edx=off, esi=x, edi=ay, eax=sx */
#pragma aux vga_drawyy= \
      "mov eax,edi" \
      "shr eax,1" \
      "sub ecx,eax" \
      "mov eax,sy" \
"loople2:" \
      "cmp esi,y2" \
      "je  fertig2" \
       "mov byte ptr VIDEOSP[edx],bh" \
       "cmp ecx,0" \
       "jl  skip12" \
       "jg  skip2" \
       "cmp eax,0" \
       "jl  skip12" \
"skip2:" \
        "add edx,sx" \
        "sub ecx,edi" \
"skip12:" \
       "add esi,eax" \
       "add edx,oy" \
       "add ecx,axx" \
       "jmp loople2" \
"fertig2:" \
       "mov byte ptr VIDEOSP[edx],bh" \
                                                parm [bh] [ecx] [edx] [esi] [edi] \
                                                modify [ecx edx esi edi eax] ;
  vga_drawyy(c,axx,off,y1,ay);
#endif
/*
        int d = axx- (ay >> 1);
        while (y1 != y2) {
            vga_pixelb(off, c);
            if (d > 0 || (d == 0 && sy == 1)) {
                off+=sx;
                d -= ay;
            }
            y1 += sy; off+=oy;
            d += axx;
        }
 */
    }
 }
//    vga_pixelb(off, c);
#ifndef __WATCOMC__
 asm {
      mov byte ptr es:VIDEOSP[edx],bh
 }
#else
#endif
 return;
}

/*fct vga_rect*/
void vga_rect(int x1,int y1,int x2,int y2,int f) {
 if (y2<y1) { int i=y1;y1=y2;y2=i; }
 vga_horli(y1,x1,x2,f);
 if (y1!=y2) vga_horli(y2,x1,x2,f);
 vga_drawline(x1,y1+1,x1,y2-1,f);
 if (x1!=x2) vga_drawline(x2,y1+1,x2,y2-1,f);
}
/*fct vga_fillrect*/
void vga_fillrect(int x1,int y1,int x2,int y2,int f) {
 int i;
 if (x2<x1) { i=x1;x1=x2;x2=i; }
 if (y2<y1) { i=y1;y1=y2;y2=i; }
 for (i=y1;i<=y2;i++)
  vga_horli(i,x1,x2,f);
}

#include "font6x8.c"
#include "font8x8.c"
#include "font8x14.c"
static unsigned char *font_adress=NULL;
static int font_height=0,font_width=0;
/*fct vga_font*/
int vga_font(int n,int color,int bcolor) {
 text_fg=color;
 if (bcolor==color) { text_bg=SNZzero; TXTDRWmode=SNZmode; }
 else               { text_bg=bcolor;  TXTDRWmode=PUTmode; }
 switch (n) {
 case 1: font_height=8; font_width=6;font_adress=font6x8;  break;
 case 2: font_height=8; font_width=8;font_adress=__font8x8;break;
 case 3: font_height=14;font_width=8;font_adress=font8x14; break;
 }
 return font_width+(font_height<<5);
}
/*fct expandcharacter*/
static void expandcharacter(char c,Pixel *bitmap ) {
 int x, y, b;
 unsigned char *font;
 font = font_adress + (((unsigned char)c)*font_height);
// Geht nur, solange width<=8 und wenn bei width<8 jedes Zeichen auf Bytegrenze
 for (y = 0; y < font_height; y++) {
  for (x = 0; x < font_width; x++) {
   if (x % 8 == 0)
    b = *font++;
   if (b & (128 >> (x % 8))) { /* pixel */
     *bitmap = text_fg;
     bitmap++;
   } else { /* background pixel */
     *bitmap = text_bg;
     bitmap++;
   }
  }
 }
}
/*fct writecompressed*/
static void writecompressed( int x, int y,char *s ) {
 Pixel bitmap[112],*bz=NULL,*p,*p1;
 int n=strlen(s);
 int i,j,nc=0;
 bz=malloc(n*font_height*font_width*sizeof(Pixel));
  while (*s != 0) {
   expandcharacter(*s++, bitmap);
   if (bz) {
     p1=bitmap;
     for (i=0;i<font_height;i++) {
      p=bz+(i*n+nc)*font_width;
      for (j=0;j<font_width;j++) *p++=*p1++;
     }
     nc++;
   } else {
    vga_putbox(x , y, font_width, font_height, bitmap);
    x += font_width;
   }
  }
  if (bz) vga_putbox(x , y, font_width*n, font_height, bz);
}
/*fct vga_text*/
void vga_text(int x,int y,char *s) {
 int svm=DRWmode;
 DRWmode=TXTDRWmode;
 writecompressed(x,y,s);
 DRWmode=svm;
}


/*fct vga_getmes*/
int vga_getmes(Evstack *evp,int warte) {
 const int mililang=500,milikurz=0;
 static int milis1=500,milis2=0;
 static clock_t lasttime=0;
 static int buttons=0,xs=0,ys=0;
 int w=0,mask=0,buttn,irep=warte?8:0;
 vga_setcur(1);
rep:;
 if (nevs==levs && _bios_keybrd(1)) {
  w=_bios_keybrd(0);
  if (w&0xff) w=w&0xff;
  else        w=(w>>8) + 300;
  mask=1;
  evp->x=xs;evp->y=ys;evp->buttn=buttons;evp->mask=key_mask;
 } else if (nevs!=levs) {
  Evstack *ev;
  int lev=levs+1;
  if (lev==Mevs) lev=0;
  ev=evstack+lev;
  buttn=ev->buttn,mask=ev->mask;
  *evp=*ev;
  levs=lev;
  if (mask==key_mask) {
   w=buttn&0xff; /*asci*/
   evp->x=xs,evp->y=ys;
   mask=1;
  } else if (mask!=tim_mask) {
   buttons=buttn;xs=ev->x;ys=ev->y;
   if (nevs!=levs && mask<2) { if (irep) { irep--;goto rep; } }
   w=-(mask+((buttons /* &7 */ )<<9));
   milis1=mililang,milis2=milikurz;
  }
 }
 if (mask==0 && warte) {
  int i,m1;
  if (milis1==mililang) m1=milis1/4;
  else                  m1=milis1;
   for (i=0;i<milis1;i+=m1) {
    if (nevs!=levs) { if (irep) { irep--;goto rep; } }
    if (clock()-lasttime > milis1/2) break;
    msleep(m1);
   }
   milis1=milis2;
  w=-((buttons /* &7 */ )<<9);
  evp->x=xs;evp->y=ys;evp->buttn=buttons;evp->mask=tim_mask;
 }
 lasttime=clock();
 return w;
}

/*fct vga_wartsync*/
void vga_wartsync(int n)
{
 register int s;
 while (n--) {
  do  s=inp(0x3da); while (s&8);
  do  s=inp(0x3da); while (!(s&8));
 }
}

/*fct __vga_delay*/
static void __vga_delay() {
 int i,k=0;
 for (i = 0; i < 10; i++) k++;
}
#define PEL_IW  0x3C8   /* PEL Write Index */
#define PEL_IR  0x3C7   /* PEL Read Index */
#define PEL_D   0x3C9   /* PEL Data Register */
/*fct vga_setpal*/
void vga_setpal(int ix,int red,int green,int blue) {
 outp(PEL_IW,ix);
  __vga_delay();
  outp(PEL_D,red>>2);
  __vga_delay();
  outp(PEL_D,green>>2);
  __vga_delay();
  outp(PEL_D,blue>>2);
}
/*fct vga_getpal*/
void vga_getpal(int ix,int *red,int *green,int *blue) {
 outp(PEL_IR,ix);
  __vga_delay();
  *red  =inp(PEL_D)<<2;
  __vga_delay();
  *green=inp(PEL_D)<<2;
  __vga_delay();
  *blue =inp(PEL_D)<<2;
}
/*fct vga_setallpal*/
void vga_setallpal(unsigned char *rgb) {
 int i,r,g,b;
 for (i=0;i<256;i++) {
  r=*rgb++; g=*rgb++; b=*rgb++;
  vga_setpal(i,r,g,b);
 }
}
/*fct vga_getallpal*/
void vga_getallpal(unsigned char *rgb) {
 int i,r,g,b;
 for (i=0;i<256;i++) {
  vga_getpal(i,&r,&g,&b);
  *rgb++=r; *rgb++=g; *rgb++=b;
 }
}

