
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <malloc.h>
#include <string.h>

#define VHAUPT
#include "wirp.h"

#if defined(XWI)||defined(TWIN)
#define stricmp strcasecmp
#endif

/* #define NODESIGN 1 */
/*fct internerror */
void internerror(char *s,char *s1) {
 FILE *fe=fopen("wirp.err","a");
 fprintf(fe,"Internal Error: %s %s\n",s,s1);
 fclose(fe);
}
/* void heaptesten(char *s) {
 if (_heapchk()!=_HEAPOK) internerror("Heap",%s);
} */

#define Min(a,b) ((a)<(b) ? (a):(b))
#define Max(a,b) ((a)>(b) ? (a):(b))

#define Pich 10
#define Picw 10
#define w 15 /*_BRIGHTWHITE*/
#define g  7 /*_WHITE*/
#define o  0 /*_BLACK*/
static Pixel Thumb[100] = {
 w,w,w,w,w,w,w,w,w,w,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,o,o,o,o,o,o,o,o,o};
static Pixel RThumb[100] = {
 o,o,o,o,o,o,o,o,o,o,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,w,w,w,w,w,w,w,w,w};
static Pixel PfeilD[100] = {
 w,w,w,w,w,w,w,w,w,w,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,o,o,o,o,o,o,g,o,
 w,g,g,o,o,o,o,g,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,o,o,o,o,o,o,o,o,o};
static Pixel RPfeilD[100] = {
 o,o,o,o,o,o,o,o,o,o,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,w,w,w,w,w,w,g,w,
 o,g,g,w,w,w,w,g,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,w,w,w,w,w,w,w,w,w};
static Pixel PfeilU[100] = {
 w,w,w,w,w,w,w,w,w,w,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,g,o,o,o,o,g,g,o,
 w,g,o,o,o,o,o,o,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,g,g,o,o,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,o,o,o,o,o,o,o,o,o};
static Pixel RPfeilU[100] = {
 o,o,o,o,o,o,o,o,o,o,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,g,w,w,w,w,g,g,w,
 o,g,w,w,w,w,w,w,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,g,g,w,w,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,w,w,w,w,w,w,w,w,w};
static Pixel PfeilR[100] = {
 w,w,w,w,w,w,w,w,w,w,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,g,o,g,g,g,o,
 w,g,g,g,g,o,o,g,g,o,
 w,g,o,o,o,o,o,o,g,o,
 w,g,o,o,o,o,o,o,g,o,
 w,g,g,g,g,o,o,g,g,o,
 w,g,g,g,g,o,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,o,o,o,o,o,o,o,o,o};
static Pixel RPfeilR[100] = {
 o,o,o,o,o,o,o,o,o,o,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,g,w,g,g,g,w,
 o,g,g,g,g,w,w,g,g,w,
 o,g,w,w,w,w,w,w,g,w,
 o,g,w,w,w,w,w,w,g,w,
 o,g,g,g,g,w,w,g,g,w,
 o,g,g,g,g,w,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,w,w,w,w,w,w,w,w,w};
static Pixel PfeilL[100] = {
 w,w,w,w,w,w,w,w,w,w,
 w,g,g,g,g,g,g,g,g,o,
 w,g,g,g,o,g,g,g,g,o,
 w,g,g,o,o,g,g,g,g,o,
 w,g,o,o,o,o,o,o,g,o,
 w,g,o,o,o,o,o,o,g,o,
 w,g,g,o,o,g,g,g,g,o,
 w,g,g,g,o,g,g,g,g,o,
 w,g,g,g,g,g,g,g,g,o,
 w,o,o,o,o,o,o,o,o,o};
static Pixel RPfeilL[100] = {
 o,o,o,o,o,o,o,o,o,o,
 o,g,g,g,g,g,g,g,g,w,
 o,g,g,g,w,g,g,g,g,w,
 o,g,g,w,w,g,g,g,g,w,
 o,g,w,w,w,w,w,w,g,w,
 o,g,w,w,w,w,w,w,g,w,
 o,g,g,w,w,g,g,g,g,w,
 o,g,g,g,w,g,g,g,g,w,
 o,g,g,g,g,g,g,g,g,w,
 o,w,w,w,w,w,w,w,w,w};
#undef w
#undef g
#undef o

char *pattstr[] = {
      "black"        , "blue"         , "green"        , "cyan"         ,
      "red"          , "magenta"      , "brown"        , "white"        ,
      "gray"         , "lightblue"    , "lightgreen"   , "lightcyan"    ,
      "lightred"     , "lightmagenta" , "yellow"       , "brightwhite"  ,
      "value"        , "verti"        , "noslider"     , "invert"       ,
      "tblack"       , "nochange"     , "tlarge"       , "listvalues"   ,
      "saveunder"    , "frthin"       , "nochild"      , "modal"        ,
      "closemodal"   , "bitmap"       , "noframe"      , "c7tlarge"     ,
      "c5tlarge"     , "check" };
#define AT_VALUE       1
#define AT_BTCHCK AT_VALUE
#define AT_VERTI       2
#define AT_NOSLID      4
#define AT_INVERT      8
#define AT_TBLACK     16
#define AT_NOCHAN     32
#define AT_TLARGE     64
#define AT_LISTVA    128
#define AT_SAVEUN    256  /*momentan nicht fuer MSW*/
#define AT_FRTHIN    512
#define AT_NOCHILD  1024
#define AT_MODAL    2048
#define AT_CLOSEM   4096
#define AT_BITMAP   8192
#define AT_NOFRAM  16384

#define W_SLIDER 1
#define W_BUTTON 2
#define W_FRAME  4
#define W_LABEL  8
#define W_LIBOX 16
#define W_ALL   31

#define ST_CHANG 1
#define ST_INVIS 2
#define ST_ARMED 4
#define ST_ARMD1 8
#define ST_BMCHN 16
#define ST_MENUE 32

static Windowst firstwinst,*firstwindow=NULL,*wmodalorfirst=NULL;
static Windowst *wlasthit=NULL,*wclosem=NULL,*winkeyb=NULL,*wstatus=NULL;
static Windowst *wlasthelpt=NULL;
static Framest firstframe;

static Evstack Lastev;
static int lastkey=0;
static Wcallb sizecallb=NULL;

static int menux=0;


#ifndef NODESIGN
static Windowst *w_versch=NULL;
#ifdef __hpux
void w_ver_quit(char *name,int i,int j);
#else
static void w_ver_quit(char *name,int i,int j);
#endif
#endif

void wpdraw(Windowst *w) ;
static w_veraendern(Windowst *w,int x,int y) ;
static void frameclient(Windowst *win) ;
static void framedrw(Windowst *win) ;
void wprinttree(Windowst *w,int lev,Windowst *f) ;
void winlist(void);
static void menuselect(int id) ;

static char frsc[128],fcsr[128];
void wresource(char *fn) {
 char *cp,*cp1;
 strncpy(frsc,fn,127); frsc[127]=0;
 cp=strstr(frsc,".WRP");
 if (!cp) cp=strstr(frsc,".wrp");
 if (!cp) {
  cp=strstr(frsc,".EXE");
  if (!cp) cp=strstr(frsc,".exe");
  if (cp) strcpy(cp,".wrp");
  else {
   cp=frsc+strlen(frsc);
   cp1= strlen(frsc)>4 ? cp-4 : frsc;
   cp1=strchr(cp1,'.');
   if (cp1 && strchr(cp1,'\\')==NULL && strchr(cp1,'/')==NULL) cp=cp1;
   strcpy(cp,".wrp");
  }
 }
 strcpy(fcsr,frsc);
 strcpy(fcsr+(cp-frsc),".TMP");
 firstwindow=NULL;
 menux=0;
#ifdef VGA
 w_enit();
 w_init();
#endif
}

void wsetsizecallb(Wcallb cb) {
 sizecallb=cb;
}
void w_sizecallb(char *m,int i,int j) {
 if (sizecallb!=NULL) (sizecallb)(m,i,j);
}

#ifdef MSW
static void menucallb(int id) ;
#else
int main(int argc,char **argv) {
 int ret;
 w_init();
 wresource(argv[0]);
 ret=cmain(argc,argv);
 w_enit();
 return ret;
}
static void menucallb(char *stname,int i,int j) ;
#endif

#define LAY_ROW 1
#define LAY_COL 2
static int layout=0,laydist,layx,layy,laynr,laynrsv,laymaxwh,layxy0;
/*fct wlayout */
void wlayout(char *par,int nr,int dist) {
 if      (!strcmp(par,"row"))    layout=LAY_ROW;
 else if (!strcmp(par,"column")) layout=LAY_COL;
 else if (!strcmp(par,"shift")) { layx+=nr;layy+=dist;return; }
 else if (!strcmp(par,"set"))   { layx=nr;layy=dist;return; }
 else layout=0;
 laynrsv=laynr=nr; laydist=dist;
 laymaxwh=0;layxy0=-1;
}
/*fct wpclip */
void wpclip(Windowst *ws) {
 int on=ws!=NULL;
 if (on) {
  xclip0=ws->x,yclip0=ws->y+yvermenu;
  xclipa=ws->w,yclipa=ws->h;
  xclip1=xclip0+xclipa-1,yclip1=yclip0+yclipa-1;
 } else {
  xclip0=0,yclip0=0,xclip1=w_mx-1,yclip1=w_my-1,xclipa=w_mx,yclipa=w_my;
 }
 w_setclip(on);
}
/*fct woutclip */
static int woutclip(Windowst *ws) {
 int x=ws->x,y=ws->y,xe=x+ws->w-1,ye=y+ws->h-1;
 return (x>xclip1||xe<xclip0||y+yvermenu>yclip1||ye+yvermenu<yclip0);
}
/*fct wmktext */
char *wmktext(char *ch) {
 char *r=NULL;
 if (ch) r=malloc(strlen(ch)+1);
 if (r) strcpy(r,ch);
 return r;
}
/*fct wmkptext */
char **wmkptext(char **pch,int n) {
 char **r=NULL;
 if (pch) r=calloc(n,sizeof(char *));
 if (r) {
  int i;
  for (i=0;i<n;i++) {
   r[i]=wmktext(pch[i]);
   if (!r[i]) {
    int j;
    for (j=0;j<i;j++) free(r[j]);
    free(r); r=NULL; break;
   }
  }
 }
 return r;
}
/*fct wfrptext */
void wfrptext(char **pch, int n) {
 if (pch) {
  int i;
  for (i=0;i<n;i++) free(pch[i]);
  free((void *)pch);
 }
}
/*fct wequtxt */
int wequtxt(char *s1,char *s2) {
 int c1,c2,ret=1;
 while (ret) {
  if ((c1=*s1++)!=0) {
   if (c1!=*s2 && (c1<=' '||c1>127)) continue;
   if ((c2=*s2++)!=0) {
    if (c1==c2) continue;
    if (c1>='a'&&c1<='z') c1-='a'-'A';
    if (c2>='a'&&c2<='z') c2-='a'-'A';
    if (c1==c2) continue;
    ret=0;
   } else ret=0;
  } else {
   if (*s2!=0) ret=0;
   else break;
  }
 }
 return ret;
}

/*fct namxywhatt */
static void namxywhatt(char *par,char **name,int *xp,int *yp,int *wp,int *hp,
                       int *attp,int *colp) {
 char *p=par,*p1=par,*n;
 int x=-1,y=-1,w=-1,h=-1,i,nc,att=0,col=0;
 while (*p && *p!=',') p++;
 i=p-p1;
 if ((n=(char *)malloc(i+1))!=NULL) { strncpy(n,p1,i);n[i]=0; }
 *name=n;
 if (*p) {
  if (*p&&isdigit(*(p+1))) x=atoi(++p);
  else if (*(p+1)==',') p++;
 }
 while (*p && *p!=',') p++;
 if (*p) {
  if (*p&&(isdigit(*(p+1))||*(p+1)=='-')) y=atoi(++p);
  else if (*(p+1)==',') p++;
 }
 while (*p && *p!=',') p++;
 if (*p) {
  if (*p&&isdigit(*(p+1))) w=atoi(++p);
  else if (*(p+1)==',') p++;
 }
 while (*p && *p!=',') p++;
 if (*p) {
  if (*p&&isdigit(*(p+1))) h=atoi(++p);
  else if (*(p+1)==',') p++;
 }
 while (*p && *p!=',') p++;
 while (*p!='\n' && *p++) {
  int iatt=1;
  p1=p;
  while (*p && *p!=',' && *p!='\n') p++;
  nc=p-p1;
  if (nc>0) {
   for (i=0;i<sizeof(pattstr)/sizeof(char *);i++) {
    if (!strncmp(pattstr[i],p1,nc)) {
     if (i<16) col=i;
     else if (i==31) { if (w_my>700) att|=AT_TLARGE; }
     else if (i==32) { if (w_my>500) att|=AT_TLARGE; }
     else if (i==33) {               att|=AT_BTCHCK; }
     else      att|=iatt;
     goto l1;
    }
    if (i>=16) iatt<<=1;
   }
   internerror("Unknown attribute:",p1);
  }
l1:;
 }
 *attp=att; *colp=col; *xp=x;*yp=y;*wp=w;*hp=h;
}

/*fct wfindname */
Windowst *wfindname(Windowst *wr,char *name) {
 Windowst *wn;
 if (wr==NULL) wr=firstwindow;
 wr=wr->child;
 while (wr) {
  if (!strcmp(wr->name,name)) return wr;
  if ((wn=wfindname(wr,name))!=NULL) return wn;
  wr=wr->next;
 }
 return NULL;
}
/*fct wnfind */
Windowst *wnfind(char *name) { return wfindname(NULL,name); }
/*fct wchildhit */
static Windowst *wchildhit(Windowst *ws,int x,int y,int typ) {
 Windowst *wn,*wc=ws->child;
 while (wc) {
  if (x>=wc->x&&x<wc->x+wc->w&&y>=wc->y&&y<wc->y+wc->h) {
   if ((wn=wchildhit(wc,x,y,typ))!=NULL) return wn;
   else if ((wc->stat&ST_INVIS)==0 && ((wc->typ)&typ)!=0) return wc;
  }
  wc=wc->next;
 }
 return NULL;
}
/*fct wprevtree */
static Windowst *wprevtree(Windowst *ws,Windowst *we) {
 Windowst *wn,*wc=ws->child;
 while (wc) {
  if (wc==we) return ws;
  if ((wn=wprevtree(wc,we))!=NULL) return wn;
  ws=wc;
  wc=wc->next;
 }
 return NULL;
}
/*fct wparentof */
static Windowst *wparentof(Windowst *ws,Windowst *we) {
 Windowst *wn,*wc=ws->child;
 while (wc) {
  if (wc==we) return ws;
  if ((wn=wparentof(wc,we))!=NULL) return wn;
  wc=wc->next;
 }
 return NULL;
}
/*fct wmvchild */
static void wmvchild(Windowst *wc,int vx,int vy) {
 wc=wc->child;
 while (wc) {
  wc->x+=vx; wc->y+=vy; wc->stat|=ST_CHANG;
  frameclient(wc);
  wmvchild(wc,vx,vy);
  wc=wc->next;
 }
}
/*fct wntotop */
void wntotop(char *name) {
 Windowst *wn,*wl=NULL;
 wn=firstwindow->child;
 while (wn) {
  if (!strcmp(name,wn->name)) {
   if (wl!=NULL) {
    wl->next=wn->next;
    wn->next=firstwindow->child;
    firstwindow->child=wn;
   }
   wpdraw(wn);
   break;
  }
  wl=wn;
  wn=wn->next;
 }
}

/*fct window */
static Windowst * window(char *name,int x,int y,int w,int h,int att,int col,
                  int typ,void *ptr) {
 static int rscfilerok=1;
 Windowst *wparent,*wst=(Windowst *)malloc(sizeof(Windowst));
 Pixel *sav=NULL;
 int wfirst=0,stat=0;
 if (!firstwindow) {
  wfirst=1;
  firstwinst.ptr=&firstframe;
  firstwinst.name="";
  firstwinst.draw=framedrw;
  firstwinst.hit =NULL;
  firstwinst.typ=W_FRAME;
  firstwinst.w=w_mx;
  firstwinst.h=w_my;
  wmodalorfirst=firstwindow=&firstwinst;
  firstframe.win=firstwindow;
  firstframe.text="";
  wlayout("column",8,8);
  wpclip(NULL);
 }
 if (wst) {
  FILE *fi;
  if (x==-1) {
   if (layout) {
    x=layx;y=layy;
   } else {
    x=y=10;
   }
  }
  if (layout) {
   if (layout==LAY_ROW) {
    if (layxy0==-1) layxy0=x;
    layx=x+w+laydist; layy=y;
    laymaxwh=Max(laymaxwh,h);
    if (--laynr==0) { layx=layxy0; layy+=laymaxwh+laydist; laymaxwh=0; laynr=laynrsv; }
   } else {
    if (layxy0==-1) layxy0=y;
    layy=y+h+laydist; layx=x;
    laymaxwh=Max(laymaxwh,w);
    if (--laynr==0) { layy=layxy0; layx+=laymaxwh+laydist; laymaxwh=0; laynr=laynrsv; }
   }
  }

  if (!(att&AT_NOCHAN) && rscfilerok) {
   if ((fi=fopen(frsc,"r"))==NULL) {
    rscfilerok=0;/* internerror("fopen rsc r","");*/
   } else {
    char z[81],*p1=z,*p; int n=strlen(name);
    while (fgets(z,80,fi)) {
     p=z;
     while (*p && *p!=',') p++;
     if (n==(p-p1) && !strncmp(p1,name,n)) {
      namxywhatt(p1,&p,&x,&y,&w,&h,&att,&col);
      if (typ==W_BUTTON && (att&AT_BITMAP) && w>0 && h>0) {
       Pixel *bm=calloc(w*h,sizeof(Pixel));
       if (bm) {
        int i,c;char ch[2];ch[1]=0;
        c=fgetc(fi);
        if (c=='(') {
         ((Buttonst *)ptr)->text=(char *)bm;
         stat|=ST_BMCHN;
         for (i=0;i<w*h;i++) {
          do {c=fgetc(fi);} while (c==' '||c=='\n');
          if (c==')') break;
          ch[0]=c;
          bm[i]=strtol(ch,NULL,16);
         }
        }
        while (c!='\n' && !feof(fi)) c=fgetc(fi);
       }
      }
      free((void *)p);
      if (w<0) w=20;
      if (h<0) h=20;
      break;
     }
    }
    fclose(fi);
   }
  }
#if defined(MSW) || defined(XWI)
  if (wfirst) {
   w_movewin(Max(x,0),Max(y,0),Max(w,20),Max(h+yvermenu,20));
   firstwinst.x=x; firstwinst.y=y; firstwinst.w=w; firstwinst.h=h;
   wpclip(NULL);
  }
#endif
  if (att&AT_CLOSEM) {
   if (wclosem) wpclose(wclosem);
   wclosem=wst;
  }
  wst->name=name;wst->x=x;wst->y=y;wst->w=w;wst->h=h;wst->typ=typ;
  wst->att=att;wst->col=col;wst->mask=0;
  wst->ptr=ptr; wst->stat=stat; wst->helptext=NULL;
  wst->child=NULL;
  if (att&AT_NOCHILD) {
   wparent=firstwindow;
  } else {
   wparent=wchildhit(firstwindow,x,y,W_FRAME|W_LIBOX);
   if (!wparent) wparent=firstwindow;
  }
  wst->next=wparent->child;
  wparent->child=wst;
  if (att&AT_MODAL) {
   if (wmodalorfirst!=firstwindow) wcmessagexy(x,y,"Multiple modal windows!");
   wmodalorfirst=wst;
  }
#ifndef MSW
#ifdef XWI
  if (xwi_visibil())
#endif
  if (att&AT_SAVEUN) sav=(Pixel *)malloc(sizeof(Pixel)*w*h);
#endif
  if (sav) { w_setcur(0); w_getbox(x,y,w,h,sav); }
  wst->save=sav;
 }
 return wst;
}

/*fct wpredraw */
void wpredraw(Windowst *wp) {
 Windowst *ws=firstwindow,*wst[100];
 int ist=0;
 /*if (wp)*/ wpclip(wp);
 w_wartsync(1);
 while (ws) {
  if (ist<100) wst[ist++]=ws;
  ws=ws->next;
 }
 while (ist--) wpdraw(wst[ist]);
 if (wp) wpclip(NULL);
}

/*fct wpclose */
void wpclose(Windowst *we) {
 static int rscfilewok=1;
 FILE *fi,*fo;
 Windowst *wp,*w;
 Buttonst *elem=we->ptr;
 int n=strlen(we->name);
 static int noredraw=0;
 if (we->mask&close_mask) {
  int r;
  Lastev.mask=close_mask;
  if (we->hit) r=(we->hit)(we,&Lastev);
  if (!r) return;
 }
#ifndef NODESIGN
 if (we==w_versch) w_ver_quit(we->name,0,0);
#endif
 while (we->child) {
  noredraw=1;
  wpclose(we->child);
  noredraw=0;
 }
 if (rscfilewok && (we->stat&ST_CHANG) && !(we->att&AT_NOCHAN) && n>0 && n<32)
/* if ((fi=fopen(frsc,"r"))==NULL) {
  rscfilewok=0; internerror("fopen rsc r1","");
 } else */ {
  char z[81],zn[81],*p1=z,*p;
  int i,gef=0,iatt=1,att=we->att;
  fi=fopen(frsc,"r");
  sprintf(zn,"%s,%d,%d,%d,%d",we->name,we->x,we->y,we->w,we->h);
  if (we->col)   { strcat(zn,","); strcat(zn,pattstr[we->col]); }
  for (i=16;i<sizeof(pattstr)/sizeof(char *);i++) {
   if (att&iatt) { strcat(zn,","); strcat(zn,pattstr[i]); }
   iatt<<=1;
  }
  strcat(zn,"\n");
  fo=fopen(fcsr,"w");
  if (fo==NULL) { internerror("fopen csr w",""); rscfilewok=0; }
  while (fi && fgets(z,80,fi)) {
   p=z;
   while (*p && *p!=',') p++;
   if (n==(p-p1) && !strncmp(p1,we->name,n)) {
    fputs(zn,fo); gef++;
    if ((att&AT_BITMAP) && (we->stat&ST_BMCHN)) {
     if (elem->text) {
      Pixel *p=(Pixel *)elem->text;
      fprintf(fo,"(");
      for (i=0;i<we->w*we->h;i++) {
        if (i%we->w==0 && i!=0) fprintf(fo,"\n ");
        fprintf(fo,"%x",p[i]);
      }
      fprintf(fo,")\n");
     }
     i=fgetc(fi);
     if (i=='(') {
      while (!feof(fi) && i!=')') i=fgetc(fi);
      i=fgetc(fi);
     } else  fputc(i,fo);
    }
   } else
    fputs(z,fo);
  }
  if (!gef) fputs(zn,fo);
  if (fi) fclose(fi);
  remove(frsc);
  fclose(fo);
  rename(fcsr,frsc);
 }
 if (we->att&AT_MODAL) wmodalorfirst=firstwindow;
 if (we->att&AT_CLOSEM) wclosem=NULL;
 if (we==wlasthit) wlasthit=NULL;
 wp=wprevtree(firstwindow,we);
 if      (wp->next ==we) wp->next=we->next;
 else if (wp->child==we) wp->child=we->next;
 if (we->save) {
  w_setcur(0);
  w_putbox(we->x,we->y,we->w,we->h,we->save);
  free(we->save);
 } else {
  if (!noredraw) wpredraw(we);
 }
 switch (we->typ) {
 case W_SLIDER: free(((Sliderst *)elem)->flist); break;
 case W_BUTTON: if (!(we->att&AT_BITMAP)) free(((Buttonst *)elem)->text);
                                                break;
 case W_FRAME:  if (((Framest *)elem)->data) {
                  int n=((Framest *)elem)->ndata;
                  if (n>0) wfrptext((char **)((Framest *)elem)->data,n);
                  else if (n==-1) drwclose(we);
                }
                free(((Framest *)elem)->text);  break;
 case W_LIBOX:  if (((Liboxst *)elem)->data) {
                  int n=((Liboxst *)elem)->ndata;
                  wfrptext((char **)((Liboxst *)elem)->data,n);
                  if ((we->stat&ST_MENUE) && we->helptext)
                   wfrptext((char **)(we->helptext),n);
                }
                free(((Liboxst *)elem)->text);  break;
 case W_LABEL:  if (((Labelst *)elem)->n==0) free(((Labelst *)elem)->text);  break;
 }
 free((void *)we->name);
 free((void *)we);
 free((void *)elem);
}

/*fct wcloseall */
void wcloseall(void) {
 while (firstwindow && firstwindow->child) wpclose(firstwindow->child);
 wmodalorfirst=wlasthit=wclosem=winkeyb=wstatus=NULL;
 sizecallb=NULL;
 lastkey=0;
}
/*fct wnclose */
void wnclose(char *name) {
 Windowst *w=wfindname(firstwindow,name);
 if (w) { w->stat|=ST_INVIS; wpclose(w); }
}

/*fct rect */
static void rect(int x1,int y1,int x2,int y2,int f) {
 if (y2<y1) { int i=y1;y1=y2;y2=i; }
 w_drawline(x1,y1,x2,y1,f);
 w_drawline(x1,y2,x2,y2,f);
 w_drawline(x1,y1+1,x1,y2-1,f);
 w_drawline(x2,y1+1,x2,y2-1,f);
}
/*fct w_getfontwh */
static void w_getfontwh(int font,int *w,int *h,int col,int bcol) {
 int fht=w_font(font,col,bcol);
 *w=fht&0x1f; *h=fht>>5;
}
/*fct w_fontwhatt */
static void w_fontwhatt(int att,int bcol,int *w,int *h) {
 int font=att&AT_TLARGE?w_largefont:w_smallfont;
 int col=(att&AT_TBLACK)||bcol==_BRIGHTWHITE ? _BLACK:_BRIGHTWHITE;
 int fht=w_font(font,col,bcol);
 *w=fht&0x1f; *h=fht>>5;
}

/*fct w_hit */
static void w_hit(Evstack *ev) {
 int x=ev->x,y=ev->y,k=ev->buttn,m=ev->mask;
 Windowst *w=wchildhit(wmodalorfirst,x,y,W_ALL);
 if (w && (m&MM_RMBDOWN) && (k&KEY_RSH)) { wcmessagexy(0,0,w->name); return; }
 Lastev=*ev;
 if (w==NULL && wmodalorfirst!=firstwindow) {
  w=wmodalorfirst;
  if (!(x>=w->x&&x<w->x+w->w&&y>=w->y&&y<w->y+w->h)) w=NULL;
 }
 if (w!=wlasthit) {
  if (wlasthit) {
   Evstack lev; lev.x=0,lev.y=0,lev.buttn=ev->buttn,lev.mask=leave_mask;
   if (wlasthit->hit)(wlasthit->hit)(wlasthit,&lev);
   if (wlasthit==wlasthelpt) wsetstatustext("");
  }
  wlasthit=w;
  if (w && w->helptext && !(w->stat&ST_MENUE)) {
   wsetstatustext(w->helptext);
   wlasthelpt=w;
  }
 }
 if (w) {
  if ((m&MM_RMBDOWN) && (k&KEY_LSH) && (k&KEY_CTRL)) w_veraendern(w,x,y);
  else if ((m&MM_LMBDOWN) && wclosem && w!=wclosem && !wparentof(wclosem,w))
    { wpclose(wclosem); wclosem=NULL; }
  else if (w->hit) (w->hit)(w,ev);
 }
}

/*fct labeldrw */
static void labeldrw(Windowst *win) {
 Labelst *s=win->ptr;
 int att=win->att;
 int txt=!(att&AT_BITMAP),col=win->col;
 int x=win->x,y=win->y,w=win->w,h=win->h;
 int nch,fh,fb;
 w_wartsync(1);
 w_setcur(0);
 if (txt) {
  int colb=col==_BLACK?_BRIGHTWHITE:_BLACK;
  char *text = s->text?s->text:win->name;
  w_getfontwh((att&AT_TLARGE)?w_largefont:w_smallfont,&fb,&fh,col,col);
  nch=strlen(text);
  if (s->n) {
/* if (!(win->stat&ST_ARMED))*/
    w_fillrect(x,y,x+w-1,y+h-1,colb);
  }
  if (!(att&AT_VERTI)) {
   if (w) {
    x+= s->n==0 ? (w-nch*fb)/2 : fb;
    y+=(h-fh)/2;
   }
   w_text(x,y,text);
  } else {
   int i;
   if (w) {
    y+=(h-nch*fh)/2;
    x+=(w-fb)/2;
   }
   for (i=0;i<nch;i++) {
    char cc[2]; cc[0]=text[i];cc[1]=0;
    w_text(x,y+i*fh,cc);
   }
  }
  if (s->n) {
   if (win->stat&ST_ARMED) {
    int col1=colb==_BLACK?_BRIGHTWHITE:_BLACK;
    if (!w) w=s->n*fb+fb;
    if (!h) h=fh*2;
    rect(win->x,win->y,win->x+w-1,win->y+h-1,col1);
    x+=s->ic*fb;
    w_drawline(x,y-1,x,y+fh+1,col1);
   }
  }
 }
}
/*fct labeledit */
static int labeledit(Windowst *win,Evstack *ev) {
 Labelst *ls=(Labelst *)win->ptr;
 if (ev->mask & MM_LMBDOWN) {
  if (win->stat&ST_ARMED) {
   win->stat&=~ST_ARMED;
   winkeyb=NULL;
  } else {
   if (winkeyb && winkeyb!=win) {
    winkeyb->stat&=~ST_ARMED;
    labeldrw(winkeyb);
   }
   win->stat|=ST_ARMED;
   winkeyb=win;
  }
  labeldrw(win);
 } else if (ev->mask & key_mask) {
  int i,ic=ls->ic,n,m=ls->n,c=lastkey;
  char *p=ls->text;
  n=strlen(p);
  if (c==8) { /* Backspace*/
   if (ic>0) {
    for (i=ic;i<=n;i++) p[i-1]=p[i];
    ic--;
   }
  } else if (c==key_del) {
    for (i=ic+1;i<=n;i++) p[i-1]=p[i];
  } else if (c==key_left) {
   if (ic>0) ic--;
  } else if (c==key_right) {
   if (ic<n) ic++;
  } else if (c<256 && c>31 && n+1<m) {
   for (i=n+1;i>ic;i--) p[i]=p[i-1];
   p[ic]=c;
   ic++;
  }
  ls->ic=ic;
  if (c==13 || c==key_up || c==key_down) {
   if (ls->callb) (ls->callb)(win->name,c,0);
  } else
   labeldrw(win);
 } else if (ev->mask & close_mask) {
  if (winkeyb==win) {
   winkeyb=NULL;
   win->mask&=~key_mask;
  }
  return 1;
 }
 return 0;
}
/*fct wcedit */
Windowst* wcedit( char *par,char *text,int n,Wcallb callb ) {
 Windowst *win;
 int x,y,w,h,att,col,fh,fb;
 char *name;
 Labelst *btst=(Labelst *)malloc(sizeof(Labelst));
 if (btst) {
  namxywhatt(par,&name,&x,&y,&w,&h,&att,&col);
  w_getfontwh((att&AT_TLARGE)?w_largefont:w_smallfont,&fb,&fh,col,col);
  if (w<0) {
   if (att&AT_BITMAP) {
    w=h=20;
   } else {
    h=fh+4;
    w= (n ? n : (text ? strlen(text) : strlen(name)))*fb+fb;
    if (att&AT_VERTI) { int i=w; w=h;h=i; }
   }
  }
  btst->n=n; btst->ic=n;
  btst->callb=callb;
  if (n) { btst->text=text; btst->ic=strlen(text); }
  else     btst->text=wmktext(text);
  win=window(name,x,y,w,h,att,col,W_LABEL,btst);
  if (win) {
   win->draw=labeldrw;
   if (n) {
    win->hit=labeledit;
    win->mask|=close_mask+key_mask;
   } else win->hit=NULL;
   labeldrw(win);
  } else { free((void *)name); free((void *)btst); btst=NULL; }
 }
 return win;
}
/*fct wclabel */
Windowst* wclabel( char *par,char *text) {
 return wcedit(par,text,0,NULL);
}
/*fct wplabeltext */
void wpsettext(Windowst *win,char *ch) {
 if (win) {
  int typ=win->typ;
  if (typ==W_LABEL) {
   Labelst *lst=win->ptr;
   if (!lst->n) {
    if (lst->text) free(lst->text);
    lst->text=" ";
    wpredraw(win);
    lst->text=wmktext(ch);
   } else {
    strncpy(lst->text,ch,lst->n);
   }
  }
  else if (typ==W_LIBOX||typ==W_BUTTON||typ==W_FRAME) {
   Framest *lst=win->ptr;
   if (lst->text) free(lst->text);
   lst->text=wmktext(ch);
  } else if (typ==W_SLIDER) {
   double v=atof(ch);
   wpsliderset(win,v);
   return;
  }
  wpdraw(win);
 }
}
/*fct wnsettext */
void wnsettext(char *name,char *ch) {
 wpsettext(wfindname(NULL,name),ch);
}

#define chksw 10
#define chksh 10
#define f 15
static Pixel chks0[] = {
  0,0,0,0,0,0,0,0,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,7,7,7,7,7,7,7,7,f,
  0,f,f,f,f,f,f,f,f,f};
static Pixel chks1[] = {
  0,0,0,0,0,0,0,0,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,f,f,f,f,f,0,f,7,f,
  0,f,f,f,f,0,0,f,7,f,
  0,f,0,f,0,0,f,f,7,f,
  0,f,0,0,0,f,f,f,7,f,
  0,f,f,0,f,f,f,f,7,f,
  0,f,f,f,f,f,f,f,7,f,
  0,7,7,7,7,7,7,7,7,f,
  0,f,f,f,f,f,f,f,f,f};
#define chklw 15
#define chklh 15
static Pixel chkl0[] = {
  7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
  0,8,8,8,8,8,8,8,8,8,8,8,8,f,7,
  0,8,0,0,0,0,0,0,0,0,0,0,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,7,7,7,7,7,7,7,7,7,7,7,f,7,
  0,f,f,f,f,f,f,f,f,f,f,f,f,f,7,
  0,7,7,7,7,7,7,7,7,7,7,7,7,7,7};
static Pixel chkl1[] = {
  7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
  0,8,8,8,8,8,8,8,8,8,8,8,8,f,7,
  0,8,0,0,0,0,0,0,0,0,0,0,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,0,f,7,f,7,
  0,8,0,f,f,f,f,f,f,0,0,f,7,f,7,
  0,8,0,f,0,f,f,f,0,0,0,f,7,f,7,
  0,8,0,f,0,0,f,0,0,0,f,f,7,f,7,
  0,8,0,f,0,0,0,0,0,f,f,f,7,f,7,
  0,8,0,f,f,0,0,0,f,f,f,f,7,f,7,
  0,8,0,f,f,f,0,f,f,f,f,f,7,f,7,
  0,8,0,f,f,f,f,f,f,f,f,f,7,f,7,
  0,8,7,7,7,7,7,7,7,7,7,7,7,f,7,
  0,f,f,f,f,f,f,f,f,f,f,f,f,f,7,
  0,7,7,7,7,7,7,7,7,7,7,7,7,7,7};
#undef f
/*fct buttondrw */
static void buttondrw(Windowst *win) {
 Buttonst *s=win->ptr;
 int att=win->att;
 int txt=!(att&AT_BITMAP),bcol=win->col;
 int x=win->x,y=win->y,w=win->w,h=win->h;
 int xt,yt,check,ch1,nch,fh,fb,tpos,bla,whi,rev=0;
 rev=win->stat&ST_ARMED;
 if (s->ires) {
  if (att&AT_BTCHCK) { check=1; ch1=*(s->ires); }
  else               { check=0; rev=*(s->ires); }
 } else              { check=0; }
 if (rev) { bla=_BRIGHTWHITE; whi=_BLACK;
  if (att&AT_INVERT) bcol=bcol<8?bcol+8:bcol-8;
 } else   { whi=_BRIGHTWHITE; bla=_BLACK; }
 w_wartsync(1);
 w_setcur(0);
 if (txt) {
  char *text = s->text?s->text:win->name;
  w_getfontwh((att&AT_TLARGE)?w_largefont:w_smallfont,&fb,&fh,
   (att&AT_TBLACK)||bcol==_BRIGHTWHITE||bcol==_YELLOW ? _BLACK:_BRIGHTWHITE, bcol);
  nch=strlen(text);
  if (check) {
   int j,cw,ch;
   Pixel *p,pr[chklw*chklh];
   if (att&AT_TLARGE) {
    cw=chklw;ch=chklh;
    if (ch1) p=chkl1; else p=chkl0;
   } else {
    cw=chksw;ch=chksh;
    if (ch1) p=chks1; else p=chks0;
   }
   for (j=0;j<cw*ch;j++) {
    pr[j]= rev&&p[j]==15 ? bcol : p[j];
    if (j<cw || j>=(ch-1)*cw || j%cw==0 || j%cw==cw-1)
     if (pr[j]==bcol) pr[j]= bcol==8 ? 7 : 8;
   }
   w_putbox(x,y,cw,ch,pr);
   if (!(att&AT_VERTI)) {
    xt=x+cw+fb/2; yt=y+1;
   } else {
    xt=x+2;       yt=y+ch+fh/2;
   }
  } else { /* no checkbt */
   w_fillrect(x+1,y+1,x+w-2,y+h-2,bcol);
   if (!(att&AT_VERTI)) {
    xt=x+(w-nch*fb)/2; yt=y+(h-fh)/2;
   } else {
    xt=x+(w-fb)/2;     yt=y+(h-nch*fh)/2;
   }
  }
  if (!(att&AT_VERTI)) {
   w_text(xt,yt,text);
  } else {
   int i;
   for (i=0;i<nch;i++) {
    char cc[2]; cc[0]=text[i];cc[1]=0;
    w_text(xt,yt+i*fh,cc);
   }
  }
  if (!check) {
   w_horli(y,x,x+w-1,whi);
   w_horli(y+h-1,x,x+w-1,bla);
   w_drawline(x,y+1,x,y+h-1,whi);
   w_drawline(x+w-1,y+1,x+w-1,y+h-1,bla);
  }
 } else { /* Bitmap*/
  Pixel *bi=NULL,*bm=(Pixel *)s->text;
  if (bm) {
   if (rev && (att&AT_INVERT)) {
    bi=malloc(sizeof(Pixel)*w*h);
    if (bi) {
     int i;
     for (i=0;i<w*h;i++) bi[i]=15-bm[i];
     bm=bi;
    }
   }
   w_putbox(x,y,w,h,bm);
   if (bi) free(bi);
  } else
   w_fillrect(x+1,y+1,x+w-2,y+h-2,bcol);
 }
}
/*fct buttonhit */
static int buttonhit(Windowst *win,Evstack *ev) {
 int mk=ev->mask,stat=win->stat;
 Buttonst *s=win->ptr;
 if ((mk&MM_LMBUP) && (stat&ST_ARMED)) {
  int ir= s->ires ? *(s->ires) : 0;
  ir=!ir;
  if (s->ires) *(s->ires)=ir;
  win->stat^=ST_ARMED;
  buttondrw(win);
  if (s->callb) (s->callb)(win->name,ir,mk);
 } else
 if (mk&MM_LMBDOWN) {
  win->stat|=ST_ARMED;
  buttondrw(win);
 } else
 if (mk==leave_mask || !(ev->buttn&LMB_DOWN)) {
  win->stat&=~ST_ARMED;
  if (stat&ST_ARMED) buttondrw(win);
 }
 return 1;
}
/*fct wcbutton */
Windowst* wcbutton(char *par,char *text,int *ires,Wcallb callb) {
 Windowst *win;
 int x,y,w,h,att,col;
 char *name;
 Buttonst *btst=(Buttonst *)malloc(sizeof(Buttonst));
 if (btst) {
  int fb,fh;
  namxywhatt(par,&name,&x,&y,&w,&h,&att,&col);
  w_getfontwh((att&AT_TLARGE)?w_largefont:w_smallfont,&fb,&fh,
   (att&AT_TBLACK)||col==_BRIGHTWHITE||col==_YELLOW ? _BLACK:_BRIGHTWHITE, col);
  if (w<0) {
   if (att&AT_BITMAP) {
    w=h=20;
   } else {
    h=fh+4; /* Texthoehe+4 */
    w= (text ? strlen(text) : strlen(name))*fb+4;
    if ((att&AT_BTCHCK)&&ires!=NULL) w+= (att&AT_TLARGE) ? chklw : chksw;
    if (att&AT_VERTI) { int i=w; w=h;h=i; }
   }
  }
  if (att&AT_BITMAP) btst->text=NULL;
  else               btst->text=wmktext(text);
  win=window(name,x,y,w,h,att,col,W_BUTTON,btst);
  btst->ires=ires;btst->callb=callb;
  if (win) {
   win->draw=buttondrw;win->hit=buttonhit;
   if ((att&AT_BITMAP) && text && !btst->text) wpbitmap(win,text);
   buttondrw(win);
  } else { free((void *)name); free((void *)btst); btst=NULL; }
 }
 return win;
}
/*fct wpbitmap */
void wpbitmap(Windowst *wb,char *bm) {
 Buttonst *bt=(Buttonst *)wb->ptr;
 if (wb->att&AT_BITMAP) {
  int w=wb->w,h=wb->h,n=w*h;
  Pixel *p=(Pixel *)bt->text;
  char ch[2]={0,0};
  if (!p) { p=calloc(n,sizeof(Pixel)); bt->text=(char *)p; }
  if (!p) return;
  while (n-- && *bm) {
   ch[0]=*bm++;
   *p++=strtol(ch,NULL,16);
  }
 }
}

/*fct w_thinframe */
static void w_thinframe(int x,int y,int w,int h) {
 w_horli(y,x,x+w-1,_BLACK);
 w_horli(y+1,x+1,x+w-1,_BRIGHTWHITE);
 w_horli(y+h-2,x+2,x+w-3,_BLACK);
 w_horli(y+h-1,x+2,x+w-1,_BRIGHTWHITE);
 w_drawline(x,y+1,x,y+h-1,_BLACK);
 w_drawline(x+1,y+2,x+1,y+h-2,_BRIGHTWHITE);
 w_drawline(x+w-2,y+2,x+w-2,y+h-2,_BLACK);
 w_drawline(x+w-1,y+2,x+w-1,y+h-2,_BRIGHTWHITE);
}
/*fct w_thikframe */
static void w_thikframe(int x,int y,int w,int h) {
 w_horli(y,x,x+w-1,_BRIGHTWHITE);
 w_horli(y+1,x+1,x+w-2,_LIGHTBLUE);
 w_horli(y+2,x+1,x+w-2,_LIGHTBLUE);
 w_horli(y+3,x+3,x+w-3,_BLACK);
 w_horli(y+h-4,x+4,x+w-4,_BRIGHTWHITE);
 w_horli(y+h-3,x+1,x+w-2,_LIGHTBLUE);
 w_horli(y+h-2,x+1,x+w-2,_LIGHTBLUE);
 w_horli(y+h-1,x+1,x+w-1,_BLACK);
 w_drawline(x,y+1,x,y+h-1,_BRIGHTWHITE);
 w_drawline(x+1,y+3,x+1,y+h-4,_LIGHTBLUE);
 w_drawline(x+2,y+3,x+2,y+h-4,_LIGHTBLUE);
 w_drawline(x+3,y+4,x+3,y+h-4,_BLACK);
 w_drawline(x+w-4,y+4,x+w-4,y+h-5,_BRIGHTWHITE);
 w_drawline(x+w-3,y+3,x+w-3,y+h-4,_LIGHTBLUE);
 w_drawline(x+w-2,y+3,x+w-2,y+h-4,_LIGHTBLUE);
 w_drawline(x+w-1,y+1,x+w-1,y+h-2,_BLACK);
}

/*fct framedrw */
static void framedrw(Windowst *win) {
 Framest *s=win->ptr;
 int att=win->att;
 int bcol=win->col;
 int x=win->x,y=win->y,w=win->w,h=win->h;
 int nch,fh,fb,xt,yt;
 char *text = s->text?s->text:win->name;
 w_wartsync(1);
 w_setcur(0);
 w_getfontwh((att&AT_TLARGE)?w_largefont:w_smallfont,&fb,&fh,
 (att&AT_TBLACK)||bcol==_BRIGHTWHITE||bcol==_YELLOW ? _BLACK:_BRIGHTWHITE, bcol);
 nch=strlen(text);
 if      (att&AT_NOFRAM) {                       xt=x+2;yt=y+1; }
 else if (att&AT_FRTHIN) { w_thinframe(x,y,w,h); xt=x+4;yt=y+3; }
 else                    { w_thikframe(x,y,w,h); xt=x+6;yt=y+5; }
 w_fillrect(s->cx,yt-1,s->cx+s->cw-1,s->cy,bcol);
 if (xt+fb*nch < x+w) w_text(xt,yt,text);
 else {
  char ch[120];
  int n=Min(119,(w-(xt-x))/fb);
  strncpy(ch,text,n);ch[n]=0;
  w_text(xt,yt,ch);
 }
 if (s->ndata==-1) drwupdatew(win);
 else w_fillrect(s->cx,s->cy,s->cx+s->cw-1,s->cy+s->ch-1,bcol);
}
/*fct frameclient */
static void frameclient(Windowst *win) {
 int bor,tbor,att=win->att;
 if (win->typ==W_FRAME||win->typ==W_LIBOX) {
  Framest *st=win->ptr;
  if (att&AT_NOFRAM) bor=0; else if (att&AT_FRTHIN) bor=2; else bor=4;
  if (att&AT_TLARGE) tbor=16; else tbor=10;
  if ((st->text!=NULL) && !strcmp(st->text,"")) tbor=0;
  st->cx=win->x+bor;st->cy=win->y+bor+tbor;st->cw=win->w-bor*2;st->ch=win->h-bor*2-tbor;
 }
}
/*fct framehit */
static int framehit(Windowst *win,Evstack *ev) {
 int mk=ev->mask,ret=1;
 Framest *s=win->ptr;
 if (mk&win->mask) {
  if (s->callb) (s->callb)(win->name,ev->x-s->cx,ev->y-s->cy);
 }
 return ret;
}
/*fct wcframe */
Windowst* wcframe(char *par,char *text,Wcallb callb) {
 Windowst *win;
 int x,y,w,h,att,col;
 char *name;
 Framest *st=(Framest *)malloc(sizeof(Framest));
 if (st) {
  namxywhatt(par,&name,&x,&y,&w,&h,&att,&col);
  if (w<0) {
    w=h=100;
  }
  st->text=wmktext(text); st->callb=callb;
  st->data=NULL; st->ndata=0;
  win=window(name,x,y,w,h,att,col,W_FRAME,st);
  if (win) {
   win->draw=framedrw;win->hit=framehit;
   frameclient(win);
   framedrw(win);
   layx=st->cx+laydist;layy=st->cy+laydist/2;
   if (st->text && strcmp(st->text,"")) layy+=8;
  } else { free((void *)name); free((void *)st); st=NULL; }
 }
 return win;
}

/*fct sliderdrw */
static void sliderdrw(Windowst *win) {
 Sliderst *s=win->ptr;
 int att=win->att;
 static clock_t jetzt,lasttime=0;
 char ch[20];
 int i,txtcol,txtcol1,fh,fb,nch,n=1,
  txt=att&AT_VALUE,bcol=win->col,
  lmb=win->stat&ST_ARMD1,
  xm=Lastev.x,ym=Lastev.y,
  x=win->x,y=win->y;
 Pixel *p;
 double val= s->flist ? s->flist[(int)s->fcur] : s->fcur;
 xm-=x;ym-=y;
 if (txt) {
  double vinc= s->flist ? val : s->finc;
  if (fmod(vinc,1.0)==0.0)       sprintf(ch,"%d",(int)val);
  else if (vinc==0.1||vinc==0.5) sprintf(ch,"%.1f",val);
  else                           sprintf(ch,"%.2f",val);
  nch=strlen(ch);
  if ((att&AT_TBLACK)||bcol==_BRIGHTWHITE)
       txtcol=_BLACK,      txtcol1=_BLUE;
  else txtcol=_BRIGHTWHITE,txtcol1=_YELLOW;
  w_getfontwh((att&AT_TLARGE)?w_mediofont:w_smallfont,&fb,&fh,txtcol,txtcol);
 }
 jetzt=clock();
 if (jetzt-lasttime<20) n=2;
 lasttime=jetzt;
 w_wartsync(n);
 w_setcur(0);
 if (!(att&AT_VERTI)) {
  int wh=win->w;
  int pos=0;
  if (s->fe!=s->fa)
   pos=(wh-Picw*3-1)*((s->fcur-s->fa)/(s->fe-s->fa));
  w_fillrect(x+Picw,y,x+wh-Picw,y+Pich-1,bcol);
  if (txt) {
   int tpos=(wh-Picw*2-nch*fb)/2;
   w_text(x+tpos+Picw,y+(Pich-fh)/2,ch);
  }
  w_horli(y,x+Picw,x+wh-Picw,_BLACK);
  w_horli(y+Pich-1,x+Picw,x+wh-Picw,_BRIGHTWHITE);
  if (lmb && xm>=0&&xm<Picw&&ym>=0&&ym<Pich) p=RPfeilL; else p=PfeilL;
  w_putbox(x,y,Picw,Pich,p);
  if (lmb && xm>wh-Picw&&xm<wh&&ym>=0&&ym<Pich) p=RPfeilR; else p=PfeilR;
  w_putbox(x+wh-Picw-1,y,Picw,Pich,p);
  if (lmb && xm>=Picw+pos&&xm<Picw*2+pos&&ym>=0&&ym<Pich) p=RThumb; else p=Thumb;
  if (txt) {
   Pixel cb[Picw*Pich];
   w_getbox(x+Picw+pos,y,Picw,Pich,cb);
   for (i=0;i<Picw*Pich;i++)
    if (cb[i]==txtcol && p[i]==_WHITE) cb[i]=txtcol1; else cb[i]=p[i];
   w_putbox(x+Picw+pos,y,Picw,Pich,cb);
  } else
   w_putbox(x+Picw+pos,y,Picw,Pich,p);
 } else {
  int wh=win->h;
  int pos=0;
  int i;
  if (s->fe!=s->fa)
   pos=(wh-Pich*3-1)*((s->fcur-s->fa)/(s->fe-s->fa));
  w_fillrect(x,y+Pich,x+Picw-1,y+wh-Pich,bcol);
  if (txt) {
   int tpos=(wh-Pich*2-nch*fh)/2;
   for (i=0;i<nch;i++) {
    char cc[2]; cc[0]=ch[i];cc[1]=0;
    w_text(x+(Picw-fb)/2,y+tpos+Picw+i*fh,cc);
   }
  }
  w_drawline(x,y+Pich,x,y+wh-Pich,_BLACK);
  w_drawline(x+Picw-1,y+Pich,x+Picw-1,y+wh-Pich,_BRIGHTWHITE);
  if (lmb && xm>=0&&xm<Picw&&ym>=0&&ym<Pich) p=RPfeilU; else p=PfeilU;
  w_putbox(x,y,Picw,Pich,p);
  if (lmb && xm>=0&&xm<Picw&&ym>=wh-Pich-1&&ym<wh) p=RPfeilD; else p=PfeilD;
  w_putbox(x,y+wh-Pich-1,Picw,Pich,p);
  if (lmb && xm>=0&&xm<Picw&&ym>=Pich+pos&&ym<Pich*2+pos) p=RThumb; else p=Thumb;
  if (txt) {
   Pixel cb[Picw*Pich];
   w_getbox(x,y+Pich+pos,Picw,Pich,cb);
   for (i=0;i<Picw*Pich;i++)
    if (cb[i]==txtcol && p[i]==_WHITE) cb[i]=txtcol1; else cb[i]=p[i];
   w_putbox(x,y+Pich+pos,Picw,Pich,cb);
  } else
   w_putbox(x,y+Pich+pos,Picw,Pich,p);
 }
}
/*fct sliderhit */
static int sliderhit(Windowst *win,Evstack *ev) {
 static int misstick=0;
 int x=ev->x,y=ev->y,k=ev->buttn,mk=ev->mask;
 Sliderst *s=win->ptr;
 int wh,armd=win->stat&ST_ARMED,armd1,armd1a=win->stat&ST_ARMD1;
 int fneg= s->fa>s->fe;
 double val;
 x-=win->x;y-=win->y;
 if (fneg && s->finc>0) return 1; /* leere listbox */
 if (mk&MM_LMBDOWN) { misstick=2;   win->stat|= ST_ARMD1; }
 else if (mk&(MM_LMBUP|leave_mask)) win->stat&=~ST_ARMD1;
 else if (mk&tim_mask) { if (misstick) misstick--; }
 armd1=win->stat&ST_ARMD1;
 if (armd1 && !((mk&tim_mask) && misstick)) {
  if (!(win->att&AT_VERTI)) {
   wh=win->w;
   if (x<Picw) {
    if (fneg) s->fcur=Min(s->fa,s->fcur-s->finc);
    else      s->fcur=Max(s->fa,s->fcur-s->finc);
   } else if (x>=wh-Picw) {
    if (fneg) s->fcur=Max(s->fe,s->fcur+s->finc);
    else      s->fcur=Min(s->fe,s->fcur+s->finc);
   } else {
    int pos=Max(0,x-Picw-Picw/2),posn,
        posa=0;
    double f=s->fcur,fae=s->fe-s->fa;
    if (fae==0.0) fae=0.000001;
    posa=(s->fcur-s->fa)*(wh-Picw*3-1)/fae;
    if (!armd) {
     if (s->fpage && pos>posa+Picw/2)    f=(s->fcur+s->fpage)-s->fa;
     else if (s->fpage && pos<posa-Picw/2) f=(s->fcur-s->fpage)-s->fa;
    }
    if (f!=s->fcur) {
     posn=f*(wh-Picw*3-1)/fae;
     if ((pos<posa)!=(pos<posn)) f=s->fcur;
    }
    if (f==s->fcur) {win->stat|=ST_ARMED; f=(s->fe-s->fa)*pos/(wh-Picw*3-1);}
    f-=fmod(f,s->finc);

    if (fneg) { f=Min(0.0,f); s->fcur= Max(s->fe, s->fa+f); }
    else      { f=Max(0.0,f); s->fcur= Min(s->fe, s->fa+f); }
   }
  } else {
   wh=win->h;
   if (y<Pich) {
    if (fneg) s->fcur=Min(s->fa,s->fcur-s->finc);
    else      s->fcur=Max(s->fa,s->fcur-s->finc);
   } else if (y>=wh-Pich) {
    if (fneg) s->fcur=Max(s->fe,s->fcur+s->finc);
    else      s->fcur=Min(s->fe,s->fcur+s->finc);
   } else {
    int pos=Max(0,y-Pich-Pich/2),posn,
        posa=0;
    double f=s->fcur,fae=s->fe-s->fa;
    if (fae==0.0) fae=0.000001;
    posa=(s->fcur-s->fa)*(wh-Pich*3-1)/fae;
    if (!armd) {
     if (s->fpage && pos>posa+Pich/2)    f=(s->fcur+s->fpage)-s->fa;
     else if (s->fpage && pos<posa-Pich/2) f=(s->fcur-s->fpage)-s->fa;
    }
    if (f!=s->fcur) {
     posn=f*(wh-Pich*3-1)/fae;
     if ((pos<posa)!=(pos<posn)) f=s->fcur;
    }
    if (f==s->fcur) {win->stat|=ST_ARMED; f=(s->fe-s->fa)*pos/(wh-Pich*3-1);}
    f-=fmod(f,s->finc);
    if (fneg) { f=Min(0.0,f); s->fcur= Max(s->fe, s->fa+f); }
    else      { f=Max(0.0,f); s->fcur= Min(s->fe, s->fa+f); }
   }
  }
  if (s->fcur!=s->flast) {
   s->flast=s->fcur;
   sliderdrw(win);
   val= s->flist ? s->flist[(int)s->fcur] : s->fcur;
   if (s->fres) *(s->fres)=val;
   if (s->callb) (s->callb)(win->name,(int)val,((int)(val*10000))%10000);
  } else if (mk&MM_LMBDOWN)
   sliderdrw(win);
 } else {
  win->stat&=~ST_ARMED;
  if (armd1a && (mk&(MM_LMBUP|leave_mask))) sliderdrw(win);
 }
 return 1;
}
/*fct wcslider */
Windowst* wcslider(char *par,double *fli /*fa,fe,finc oder listval*/,
                 double *fres,Wcallb callb) {
 Windowst *win;
 int x,y,wh,dum,att,col;
 char *name;
 Sliderst *slst=(Sliderst *)malloc(sizeof(Sliderst));
 if (slst) {
  namxywhatt(par,&name,&x,&y,&wh,&dum,&att,&col);
  if (att&AT_VERTI) wh=dum;
  if (wh<0) {
   wh=50;
  }
  win=window(name,x,y,!(att&AT_VERTI)?wh:Picw,!(att&AT_VERTI)?Pich:wh,att,col,W_SLIDER,slst);
  slst->fres=fres;slst->callb=callb;
  if (att&AT_LISTVA) {
   int i,n=fli[0],init=0;
   if ((slst->flist=(double *)malloc(sizeof(double)*n))!=NULL) {
    for (i=0;i<n;i++) {
     slst->flist[i]=fli[i+1];
     if (fres && fli[i+1]==*fres) init=i;
    }
   }
   slst->fa=0;slst->fe=n-1;slst->finc=1;slst->fpage=0;slst->fcur=init;
  } else {
   slst->flist=NULL;
   slst->fa=fli[0];slst->fe=fli[1];slst->finc=fli[2];slst->fpage=fli[3];
   slst->fcur=fres?*fres:fli[0];
  }
  slst->flast=slst->fcur;
  if (win) {
   win->draw=sliderdrw;win->hit=sliderhit;
   sliderdrw(win);
  } else { free((void *)name); free((void *)slst); slst=NULL; }
 }
 return win;
}
/*fct wpsliderset */
void wpsliderset(Windowst *win,double val) {
 if (win) {
  Sliderst *s=win->ptr;
  if (s->fa<s->fe) {
   if (val<s->fa) val=s->fa;
   if (val>s->fe) val=s->fe;
  } else {
   if (val>s->fa) val=s->fa;
   if (val<s->fe) val=s->fe;
  }
  s->fcur=s->flast=val;
  if (s->fres) *(s->fres)=val;
  win->draw(win);
 }
}
/*fct wnsliderset */
void wnsliderset(char *name,double val) {
 wpsliderset(wfindname(NULL,name),val);
}

/*fct lb_slidercb */
void lb_slidercb(char *slwname,int iv,int in) {
 Windowst *slw=wfindname(NULL,slwname);
 Sliderst *slst=slw->ptr;
 int ntext=slst->fe,iakt=slst->fcur-1;
 Windowst *frw=wparentof(firstwindow,slw);
 if (frw && frw->typ==W_LIBOX) {
  const int abst=2;
  Liboxst *frst=(Liboxst *)frw->ptr;
  char **ptext=(char **)frst->data;
  int att=frw->att;
  int cx=frst->cx,cy=frst->cy,cw=frst->cw,ch=frst->ch;
  int bcol=frw->col;
  int th,tb,nl;
  int i,sldw=(slw->stat&ST_INVIS)?0:Picw;
  Windowst wcl;
  int font=(att&AT_TLARGE)?w_largefont:w_smallfont,
      fcol=(att&AT_TBLACK)||bcol==_BRIGHTWHITE ? _BLACK:_BRIGHTWHITE,
      bcolh= bcol==_WHITE ? _LIGHTBLUE:_WHITE;
  w_getfontwh(font,&tb,&th,fcol,bcol);
  th+=1;
  nl=frst->ch/th;
  wcl.x=cx,wcl.y=cy,wcl.w=cw-sldw,wcl.h=ch;
  if (frst->hili==0) w_fillrect(cx,cy,cx+cw-1-sldw,cy+ch-1,bcol);
  wpclip(&wcl);
  for (i=0;i<nl;i++) {
   if (i+iakt<ntext && iakt>=0) {
    int line=i+iakt+1;
    int hi= line==frst->hili && (unsigned char)(ptext[line-1][0]) != (unsigned char)Cinactive;
    w_font(font,fcol,hi ? bcolh:bcol);
    w_text(cx+abst,cy+abst+i*th,ptext[line-1]);
   }
  }
  wpclip(NULL);
 }
 return;
}
/*fct listboxdrw */
static void listboxdrw(Windowst *frw) {
 Liboxst *lst=frw->ptr;
 Windowst *slw=(Windowst *)(frw->child);
 w_wartsync(1);
 if (lst->hili==0) framedrw(frw);
 if (slw && slw->typ==W_SLIDER) lb_slidercb(slw->name,0,0);
}

/*fct wpxyinclient */
int wpxyinclient(Windowst *frw,int *xp,int *yp) {
 int ret=0,x=*xp,y=*yp;
 if (frw->typ==W_FRAME || frw->typ==W_LIBOX) {
  Framest *frs=frw->ptr;
  x-=frs->cx;
  y-=frs->cy;
  ret= x>=0 && x<frs->cw && y>=0 && y<=frs->ch;
  *xp=x;*yp=y;
 }
 return ret;
}

/*fct lb_hit */
static int lb_hit(Windowst *frw,Evstack *ev) {
 static int lhelpt;
 int ret=1,lhelptn=0;
 Liboxst *frst=frw->ptr;
 Windowst *slw=(Windowst *)(frw->child);
 if ((ev->mask&frw->mask) && slw && slw->typ==W_SLIDER) {
  Sliderst *slst=slw->ptr;
  int ntext=slst->fe,iakt=slst->fcur-1;
  const int abst=2;
  char **ptext=(char **)frst->data;
  int att=frw->att;
  int cx=frst->cx,cy=frst->cy,cw=frst->cw,ch=frst->ch;
  int x=ev->x,y=ev->y;
  int th,tb,nl;
  w_getfontwh((att&AT_TLARGE)?w_largefont:w_smallfont,&tb,&th,_WHITE,_WHITE);
  nl=frst->ch/(th+1);
  if (ev->mask&close_mask) { x=cx+abst; y=cy+abst; }
  if (wpxyinclient(frw,&x,&y)) {
   int i=(y-abst)/(th+1);
   int j=(x-abst)/tb;
   if (i<nl && i+iakt<ntext) {
    if ((frw->stat&ST_MENUE) && (ev->mask&MM_MOVE)) {
     if (frw->helptext) {
      if (lhelpt!=i+iakt+1)
       wsetstatustext(((char **)(frw->helptext))[i+iakt]);
      lhelptn=i+iakt+1;
     }
    } else {
     if (frst->callb) (frst->callb)(frw->name,i+iakt+1,j);
    }
   }
  }
 }
 lhelpt=lhelptn;
 return ret;
}
/*fct wclistbox */
Windowst *wclistbox(char *par,char *text,int ntext,char **ptext,Wcallb callb) {
 Windowst *slw,*win=NULL;
 int x,y,w,h,att,col;
 char *name;
 char slpar[120];
 double slv[4];
 Liboxst *lst=(Liboxst *)malloc(sizeof(Liboxst));
 if (lst) {
  namxywhatt(par,&name,&x,&y,&w,&h,&att,&col);
  if (w<0) w=Max(100, text==NULL ? 0 : (strlen(text)+2)*((att&AT_TLARGE)?8:6) );
  if (h<0) h=(ntext+1)*((att&AT_TLARGE)?16:10)+4;
  lst->text=wmktext(text); lst->callb=callb; lst->cbl=NULL; lst->hili=0;
  win=window(name,x,y,w,h,att,col,W_LIBOX,lst);
  if (win) {
   frameclient(win);
   slv[0]=1;slv[1]=ntext;slv[2]=1;slv[3]=(int)lst->ch/((att&AT_TLARGE)?16:10);
   lst->data=(void *)wmkptext(ptext,ntext); lst->ndata=ntext;
   win->draw=listboxdrw; win->hit=lb_hit;
   listboxdrw(win);
   strcpy(slpar,par);
   sprintf(&slpar[strcspn(par,",")],"_sl,%d,%d,%d,%d,verti,value,white,nochange",
                          lst->cx+lst->cw-Picw,lst->cy,Picw,lst->ch);
   slw=wcslider(slpar,slv,NULL,lb_slidercb);
   if (att&AT_NOSLID) slw->stat|=ST_INVIS;
   if (slw) lb_slidercb(slw->name,1,0);
  } else { free((void *)name); free((void *)lst); lst=NULL; }
 }
 return win;
}
/*fct wpboxadd */
void wpboxadd(Windowst *w,char *text,int line) {
 if (w && w->typ==W_LIBOX) {
  Windowst *slw=w->child;
  Liboxst *fra=(Liboxst *)w->ptr;
  if (fra->data) {
   char **pt=fra->data;
   int n=fra->ndata+1;
   pt=realloc(pt,n*sizeof(char *));
   if (pt) {
    fra->data=pt;
    if (line>=n) line=n-1;
    if (line>=0) {
     fra->ndata=n;
     if (slw && slw->typ==W_SLIDER) {
      Sliderst *sls=(Sliderst *)slw->ptr;
      sls->fe=n;
      sls->fcur=Min(sls->fcur,n);
     }
     while (--n>line) pt[n]=pt[n-1];
     pt[line]=wmktext(text);
/*   wpdraw(w);*/
    }
   }
  }
 }
}
/*fct wnboxadd */
void wnboxadd(char *name,char *text,int line) {
 wpboxadd(wfindname(NULL,name),text,line);
}
/*fct wpboxdel */
void wpboxdel(Windowst *w,int line) {
 if (w && w->typ==W_LIBOX) {
  Windowst *slw=w->child;
  Liboxst *fra=(Liboxst *)w->ptr;
  if (fra->data) {
   char **pt=fra->data;
   int n=fra->ndata;
   if (pt && n>0) {
    int i;
    if (line>n) line=n;
    if (line<=0)line=1;
    fra->ndata=n-1;
    for (i=line;i<n;i++) pt[i-1]=pt[i];
    if (slw && slw->typ==W_SLIDER) {
     Sliderst *sls=(Sliderst *)slw->ptr;
     sls->fe=n-1;
    }
/*  wpdraw(w);*/
   }
  }
 }
}
/*fct wnboxdel */
void wnboxdel(char *name,int line) {
 wpboxdel(wfindname(NULL,name),line);
}
/*fct wboxdelall */
void wpboxdelall(Windowst *w) {
 int i,n;
 if (w!=NULL) {
  Liboxst *fra=(Liboxst *)w->ptr;
  if (fra->data) {
   n=fra->ndata;
   for (i=0;i<n;i++) wpboxdel(w,9999);
  }
 }
}

/*fct cblb_callb */
static void cblb_callb(char *winname,int line,int col) {
 static int lhelpt;
 Windowst *win=wfindname(NULL,winname);
 char slpar[120];
 int n=strlen(winname),lhelptn=0;
 Liboxst *fra=(Liboxst *)(win->ptr);
 strcpy(slpar,win->name);
 if (!strcmp(slpar+n-3,"_lb")) {
  Windowst *cbw;
  slpar[n-3]=0;
  cbw=wfindname(NULL,slpar);
  if (cbw && cbw->typ==W_LIBOX) {
   Liboxst *lst=(Liboxst *)cbw->ptr;
   if (Lastev.mask&(MM_LMBDOWN|MM_LMBUP)) {
    if (!(cbw->att&AT_NOSLID)) {
     free(lst->text);
     lst->text=wmktext(((char **)(lst->data))[line-1]);
    }
    cbw->stat&=~ST_ARMED;
    (cbw->draw)(cbw);
    win->mask&=~close_mask;
    wpclose(win);
    strcpy(slpar,cbw->name);
    if (((unsigned char **)(lst->data))[line-1][0] != (unsigned char)Cinactive) {
     if (lst->callb) (lst->callb)(cbw->name,line,col);
 /* Falls im vorigen Callback cbw closed (und evt.mit gleichem Namen opened) */
     if (wnfind(slpar)==cbw && (cbw->att&AT_MODAL)) wpclose(cbw);
    }
   } else if (Lastev.mask&MM_MOVE) {
    if (cbw->helptext && (cbw->stat&ST_MENUE))
     if (lhelpt!=line)
       wsetstatustext(((char **)(cbw->helptext))[line-1]);
     lhelptn=line;
    if (fra->hili!=line) {
 /*  if (((char **)(lst->data))[line-1][0] == Cinactive) {
      if (fra->hili==0) goto l1;
      else  fra->hili=0;
     } else fra->hili=line; */
            fra->hili=line;
     (win->draw)(win);
  l1:;
    }
   } else if (Lastev.mask&close_mask) {
    cbw->stat&=~ST_ARMED;
    (cbw->draw)(cbw);
   }
  }
 }
 lhelpt=lhelptn;
 return;
}
/*fct comboboxdrw */
static void comboboxdrw(Windowst *frw) {
 int sta=frw->stat;
 Pixel *p;
 char slpar[120];
 Framest *fra=(Framest *)(frw->ptr);
 framedrw(frw);
 if (!(frw->att&AT_NOSLID)) {
  if (frw->stat&ST_ARMED) p=RPfeilD; else p=PfeilD;
  w_putbox(fra->cx+fra->cw-Picw-1,frw->y+(frw->h-Pich)/2,Picw,Pich,p);
 }
}
/*fct cb_callb */
static int cb_callb(Windowst *win,Evstack *ev) {
 int sta=win->stat,col=(win->col)&0xf,att=win->att;
 char slpar[120];
 Framest *fra=(Framest *)(win->ptr);
 if (!(ev->mask&MM_LMBDOWN)) return 1;
 strcpy(slpar,win->name); strcat(slpar,"_lb");
 if (wfindname(NULL,slpar)) {
  wnclose(slpar);
 } else {
  Windowst *wlb,*wc;
  char cbpar[80];
  int i,th,tb,nl,h=win->h,w=win->w,x=win->x,y=win->y,hh,ww,nosl=1,mcol=0;
  if (!fra->data) return 1;
  for (i=0;i<fra->ndata;i++) mcol=Max(mcol,strlen(((char **)fra->data)[i]));
  w_getfontwh((att&AT_TLARGE)?w_largefont:w_smallfont,&tb,&th,_WHITE,_WHITE);
  hh=(th+1)*fra->ndata+6;
  if (y+h+hh < w_my) y=y+h+1;
  else if (y-hh > 0) y=y-hh;
  else if (y < w_my-(y+h)) { nosl=0; y=y+h+1; hh=w_my-y; }
  else                     { nosl=0; hh=y; y=1; }
  ww=Max(w,(tb+1)*mcol+(nosl?0:Picw));
  if (x+ww > w_mx) { if (x+w-ww > 0) x=x+w-ww; else ww=w; }
  strcpy(cbpar,pattstr[col]);
  if (att&AT_TLARGE) strcat(cbpar,",tlarge");
  if (att&AT_TBLACK) strcat(cbpar,",tblack");
  if (!(att&AT_CLOSEM)) strcat(cbpar,",closemodal");
  if (nosl         ) strcat(cbpar,",noslider");
  sprintf(&slpar[strlen(slpar)],
         ",%d,%d,%d,%d,%s,nochange,frthin,nochild,saveunder",
          x,y,ww,hh,cbpar);
  wlb=wclistbox(slpar,"",fra->ndata,fra->data,cblb_callb);
  wlb->mask|=close_mask+MM_LMBUP + /*((win->stat&ST_MENUE)?*/MM_MOVE/*:0)*/ ;
  win->stat=sta|ST_ARMED;
  comboboxdrw(win);
 }
 return 1;
}
/*fct wccombobox */
Windowst *wccombobox(char *par,char *text,int ntext,char **ptext,Wcallb callb) {
 Windowst *win=NULL;
 int x,y,w,h,att,col,fh,fb,bor;
 char *name;
 char slpar[120];
 double slv[4];
 Liboxst *lst=(Liboxst *)malloc(sizeof(Liboxst));
 if (lst) {
  namxywhatt(par,&name,&x,&y,&w,&h,&att,&col);
  bor=att&AT_NOFRAM?2:(att&AT_FRTHIN?6:10);
  w_fontwhatt(att,col,&fb,&fh);
  if (w<0) w=(text==NULL ? 100 : strlen(text)*fb+fb+bor+(att&AT_NOSLID?0:Picw));
  if (h<0) h=fh+bor;
  lst->text=wmktext(text); lst->callb=callb;
  win=window(name,x,y,w,h,att,col,W_LIBOX,lst);
  if (win) {
   frameclient(win);
   lst->data=(void *)wmkptext(ptext,ntext); lst->ndata=ntext;
   win->draw=comboboxdrw;
   win->hit=cb_callb;
   comboboxdrw(win);
   if (att&AT_MODAL ) {
    Evstack ev;
    ev=Lastev;ev.mask|=MM_LMBDOWN;
    cb_callb(win,&ev);
   }
  } else { free((void *)name); free((void *)lst); lst=NULL; }
 }
 return win;
}
/*fct wpcombotxt */
char *wpcombotxt(Windowst *win,int i) {
 Framest *fra=(Framest *)(win->ptr);
 if (fra->ndata > --i) return ((char **)(fra->data))[i];
 return NULL;
}
/*fct wncomboset */
void wncomboset(char *name,int ix) {
 int i=ix-1;
 Windowst *w=wfindname(NULL,name);
 if (w!=NULL) {
  Liboxst *lst=w->ptr;
  if (lst->ndata>i) {
   free(lst->text);
   lst->text=wmktext(((char **)(lst->data))[i]);
   comboboxdrw(w);
   if (lst->callb) (lst->callb)(name,ix,0);
  }
 }
}

/*fct wpdraw */
void wpdraw(Windowst *w) {
 if (!w) return;
 if (w->draw && !(w->stat&ST_INVIS) && !woutclip(w)) {
  if (w->typ==W_LIBOX) ((Liboxst *)w->ptr)->hili=0;
  (w->draw)(w);
  if (w->child) {
   Windowst *ws=w->child,*wst[100];
   int ist=0;
   while (ws) {
    if (ist<100) wst[ist++]=ws;
    ws=ws->next;
   }
   while (ist--) wpdraw(wst[ist]);
  }
 }
}
/*fct wndraw */
void wndraw(char *name) {
 wpdraw(wfindname(NULL,name));
}

/*fct cb_wmessagexy */
static void cb_wmessagexy(char *wname,int i,int j) {
 wnclose(wname);
 return;
}
/*fct wcmessagexy */
void wcmessagexy(int x,int y,char *s) {
 char *cp,*cp1,ls[200],ch[120];
 int i,nl=1,w=(strlen(s)+2)*8,h=30;
 Windowst *frp;
 if (wmodalorfirst!=firstwindow) {
  Pixel *sav=NULL; /*(Pixel *)malloc(sizeof(Pixel)*w*h);*/
  Evstack ev;
  if (sav) w_getbox(x,y,w,h,sav);
  w_fillrect(x,y,x+w-1,y+h-1,_WHITE);
  w_text(x,y,s);
  do  i=w_getmes(&ev,1); while (i!=27 && i!=13);
  if (sav) w_putbox(x,y,w,h,sav);
 } else {
  nl=0; cp=s;
  while ((cp=strstr(cp,"\n"))!=NULL) { cp++; nl++; }
  cp=strstr(s,"\n"); if (cp) i=(cp-s)-1; else i=strlen(s)+1;
  strncpy(ls,s,i); ls[i]=0;
  h+=nl*16; w=(i+2)*8;
  if (x+w>w_mx) x=w_mx-w-2;
  if (y+h>w_my) y=w_my-h-2;
  sprintf(ch,"f_w_message,%d,%d,%d,%d,brightwhite,tlarge,nochange,"
             "saveunder,closemodal,nochild" ,x,y,w,h);
  frp=wcframe(ch,ls,cb_wmessagexy);
  frp->mask|=MM_LMBUP;
  nl=0; cp=strstr(s,"\n");
  while (cp!=NULL) {
   cp1=strstr(++cp,"\n"); if (cp1) i=cp1-cp; else i=strlen(cp)+1;
   strncpy(ls,cp,i); ls[i]=0;
   cp=cp1;
   sprintf(ch,"f_w_messlab%d,%d,%d,%d,%d,nochange"
                    ,nl,x+10,y+20+nl*16,w-10,16);
   wclabel(ch,ls);
   nl++;
  }
 }
}

/*fct wnextmes */
int wnextmes(int warte) {
 int i=0;
 Evstack ev;
 while (firstwindow->child) {
  i=w_getmes(&ev,warte);
  if (i!=0) {
   ev.y-=yvermenu;
   if (wclosem && (i>0 || ev.mask==menu_mask)) wpclose(wclosem);
   if (i<0) {
    if (ev.mask==paint_mask) wpredraw(NULL);
 #ifdef MSW
    else if (ev.mask==menu_mask) menucallb(ev.buttn);
 /* else if (ev.mask==menuselect_mask) menuselect(ev.buttn);*/
 #endif
    else w_hit(&ev);
   } else if (i==20) {
    char *p="",**ppc=&p;
    Windowst *testwindow;
    if ((testwindow=wfindname(NULL,"_test_"))==NULL)
     testwindow=wclistbox("_test_,10,280,239,99,white,nochild","test",1,ppc,NULL);
    wprinttree(NULL,0,testwindow);
    wpdraw(testwindow);
   } else if (i==12) {
    winlist();
   } else if (i>0 && winkeyb) {
    lastkey=i;
    if (winkeyb->hit && (winkeyb->mask&key_mask)) (winkeyb->hit)(winkeyb,&ev);
   }
  }
  if (i || !warte) break;
 }
 return i;
}
/*fct wloop */
int wloop(void) { return wnextmes(1); }
/*fct wpeek */
int wpeek(void) { return wnextmes(0); }
/*fct wnsetmodal */
void wnsetmodal(char *name) {
 Windowst *w;
 if (name==NULL) wmodalorfirst=firstwindow;
 else {
  w=wfindname(NULL,name);
  if (w) {
   if (wmodalorfirst==firstwindow || wmodalorfirst==NULL) wmodalorfirst=w;
  }
 }
}

/* Begin PalEdit */
static double colnr=0,red,green,blue;

/*fct pal_cnrcb */
static void pal_cnrcb(char *wn,int iv,int in) {
 int i,r,g,b,col=(int)colnr;
 Windowst *win;
 if ((win=wnfind("w_pal_BM"))!=NULL) { win->col=col; wpdraw(win); }
 w_getpal(col,&r,&g,&b);
 if ((win=wfindname(NULL,"w_pal_Red"  ))!=NULL) wpsliderset(win,(double)r);
 if ((win=wfindname(NULL,"w_pal_Green"))!=NULL) wpsliderset(win,(double)g);
 if ((win=wfindname(NULL,"w_pal_Blue" ))!=NULL) wpsliderset(win,(double)b);
 return;
}
/*fct pal_colcb */
static void pal_colcb(char *wname,int i,int j) {
 w_setpal((int)colnr,(int)red,(int)green,(int)blue);
 wndraw("w_pal_BM");
 return;
}
/*fct pal_quit */
static void pal_quit(char *w,int f,int j) {
 wnclose("w_pal_f0");
 wpdraw(firstwindow);
 return;
}
/*fct wcpaledit */
void wcpaledit(int col,int x,int y) {
 int i;
 char ch[64];
 double slcolnr[]={0,255,1,16};
 Windowst *win;
 wnclose("w_pal_f0");
 colnr=col;
 sprintf(ch,"w_pal_f0,%d,%d,66,128,cyan,nochange,nochild",x,y);
 wcframe(ch,"PalEdit",NULL);
 wlayout("column",8,8);
 wlayout("shift",-2,-7);
 win=
 wcslider("w_pal_Colnumber,white,value,nochange",slcolnr,&colnr,pal_cnrcb);
 wcslider("w_pal_Red,red,value,nochange",slcolnr,&red,pal_colcb);
 wcslider("w_pal_Green,green,value,nochange",slcolnr,&green,pal_colcb);
 wcslider("w_pal_Blue,blue,value,nochange",slcolnr,&blue,pal_colcb);
 wcbutton("w_pal_BM,,,50,10,nochange","",NULL,NULL);
 wcbutton("w_pal_Stop,lightred,nochange","Close",NULL,pal_quit);
 pal_cnrcb(win->name,col,0);
}
/* End   PalEdit */

/* Begin Designer */
#ifdef NODESIGN
static w_veraendern(Windowst *w,int x,int y) {}
#else
static int ver_bmpix=0;
static double ver_grid=4;
/*fct w_ver_callb */
static void w_ver_callb(char *w_nam,int i,int j) {
 Windowst *w=w_versch;
 int x=w->x,y=w->y,b=w->w,h=w->h;
 int vgr=ver_grid,vgr2=ver_grid/2;
 int xn,xm=-1,yn,ym,k,move=!strcmp(w_nam,"f_w_ver_move");
 int ma=w_getmode();
 Evstack ev;
 w_setcur(0);
 w_setmode(XORmode);
 rect(x,y,x+b-1,y+h-1,_BRIGHTWHITE);
 do {
  w_setmode(ma);
  k=w_getmes(&ev,1);if (k==27) break; xn=ev.x;yn=ev.y-yvermenu;k=ev.buttn;
  if (xm==-1) { xm=xn;ym=yn; }
  w_setcur(0);
  w_setmode(XORmode);
  if (!(k&LMB_DOWN)) {
   if (xn!=xm || yn!=ym) {
    rect(x,y,x+b-1,y+h-1,_BRIGHTWHITE);
    if (!move) {
     int ba=b,ha=h;
     b+=(xn-xm);b+=vgr2;b-=b%vgr; if (b<10) b=10;
     h+=(yn-ym);h+=vgr2;h-=h%vgr; if (h<10) h=10;
     if (ba!=b || ha!=h) { xm=xn; ym=yn; }
    } else {
     int xa=x,ya=y;
     x+=(xn-xm);x+=vgr2;x-=x%vgr;
     y+=(yn-ym);y+=vgr2;y-=y%vgr;
     if (xa!=x || ya!=y) { xm=xn; ym=yn; }
    }
    rect(x,y,x+b-1,y+h-1,_BRIGHTWHITE);
   }
  } else break;
 } while (1);
 rect(x,y,x+b-1,y+h-1,_BRIGHTWHITE);
 w_setmode(ma);
 if (x!=w->x || y!=w->y || b!=w->w || h!=w->h) {
  int x1=w->x,y1=w->y,x2=w->x+w->w,y2=w->y+w->h,vx=x-w->x,vy=y-w->y;
  Windowst walt=*w;
  w->x=x;w->y=y; w->w=b;w->h=h; w->stat|=ST_CHANG;
  frameclient(w);
  if ((vx || vy) && w->child) { wmvchild(w,vx,vy); }
  if (w->save) {
   w_putbox(x1,y1,x2-x1,y2-y1,w->save);
   free((void *)w->save);
   w->save=(Pixel *)malloc(sizeof(Pixel)*b*h);
   if (w->save) w_getbox(x,y,b,h,w->save);
  } else {
   int no=w->stat; w->stat|=ST_INVIS;
   wpredraw(&walt);
   w->stat=no;
  }
  wpdraw(w);
 }
 return;
}
/*fct w_ver_colcallb */
static int w_ver_colcallb(Windowst *st,Evstack *ev) {
 int c=atoi(st->name+10);
 int mk=ev->mask;
 if (mk&MM_LMBDOWN) {
  if ((w_versch->col) !=c) {
   w_versch->col=c;
   w_versch->stat|=ST_CHANG;
  }
  wpdraw(w_versch);
 } else
 if (mk&MM_RMBDOWN) {
  int x=ev->x+60,y=ev->y;
  if (x+70>w_mx) x=ev->x-140;
  if (y+130>w_my) y=w_my-130;
  wcpaledit(c,x,y);
 }
 return 1;
}
/*fct w_ver_btcallb */
static void w_ver_btcallb(char *stname,int i,int j) {
 int at=0;
 if      (strstr(stname,"vert")) at=AT_VERTI;
 else if (strstr(stname,"inve")) at=AT_INVERT;
 else if (strstr(stname,"tbla")) at=AT_TBLACK;
 else if (strstr(stname,"tlar")) at=AT_TLARGE;
 else if (strstr(stname,"valu")) at=AT_VALUE;
 else if (strstr(stname,"fthi")) at=AT_FRTHIN;
 else if (strstr(stname,"nchi")) at=AT_NOCHILD;
 if (i==0 ^ (w_versch->att&at)==0) {
  w_versch->att^=at;
  w_versch->stat|=ST_CHANG;
 }
 wpdraw(w_versch);
 return;
}
/*fct w_ver_bmdraw */
static void w_ver_bmdraw(Windowst *st) {
 Framest *fst=st->ptr;
 w_setcur(0);
 if (w_versch) {
  Buttonst *btv=(Buttonst *)w_versch->ptr;
  Pixel *bm=(Pixel *)btv->text;
  int wx=w_versch->x,wy=w_versch->y,ww=w_versch->w,wh=w_versch->h,
      cx=st->x,cy=st->y,
      i,j;
  if (bm) {
   for (i=0;i<wh;i++)
    for (j=0;j<ww;j++) {
     w_fillrect(cx+j*ver_bmpix,cy+i*ver_bmpix,cx+(j+1)*ver_bmpix-1,cy+(i+1)*ver_bmpix-1,bm[i*ww+j]);
   }
  }
 }
}
/*fct w_ver_bmcallb */
static int w_ver_bmcallb(Windowst *st,Evstack *ev) {
 Framest *fst=st->ptr;
 static int xa=-1,ya=0,xl=-1,yl=0,xx=0,yx=0;
 unsigned int
     x=ev->x-st->x,
     y=ev->y-st->y,
    bt=ev->buttn,
    mk=ev->mask;
 if (w_versch) {
  Buttonst *btv=(Buttonst *)w_versch->ptr;
  Pixel *bm=(Pixel *)btv->text;
  int i,ww=w_versch->w,wh=w_versch->h;
  if (!bm) {
   bm=calloc(ww*wh,sizeof(Pixel));
   btv->text=(char *)bm;
   if (bm) {
    for (i=0;i<ww*wh;i++) bm[i]=w_versch->col;
    w_versch->stat|=ST_BMCHN+ST_CHANG;
   }
  }
  x/=ver_bmpix;y/=ver_bmpix;
  if ((mk&(MM_LMBDOWN+MM_RMBDOWN)) && x<ww && y<wh) { xa=x;ya=y; xx=ev->x;yx=ev->y; }
  if ((mk&(MM_LMBDOWN+MM_RMBUP)) && xa!=-1) {
   if (xa<x) { i=xa;xa=x;x=i; }
   if (ya<y) { i=ya;ya=y;y=i; }
   xl=x;
   do {
    do {
     if (bm && x<ww && y<wh) {
      bm[x+y*ww]=w_versch->col;
      w_versch->stat|=ST_BMCHN+ST_CHANG;
     }
    } while (x++<xa);
    x=xl;
   } while (y++<ya);
   w_ver_bmdraw(st);
   xa=xl=-1;
   wpdraw(w_versch);
  } else if (mk&leave_mask) {
   w_ver_bmdraw(st);
   xa=xl=-1;
  } else if (xa!=-1 && (ev->x!=xl || ev->y!=yl)) {
   int ma=w_getmode();
   w_setcur(0);
   w_wartsync(1);
   w_setmode(XORmode);
   if (xl!=-1)
   w_rect(xl,yl,xx,yx,_BRIGHTWHITE);
   if (x<ww && y<wh) {
    x=ev->x;y=ev->y;
    w_rect(x ,y ,xx,yx,_BRIGHTWHITE);
    xl=x;yl=y;
   } else xl=-1;
   w_setmode(ma);
  }
 }
 return 1;
}
/*fct w_ver_quit */
void w_ver_quit(char *stname,int i,int j) {
 wnclose("f_w_ver");
 w_versch=NULL;
 return;
}
/*fct w_veraendern */
static int w_veraendern(Windowst *w,int x,int y) {
 char ch[64];
 Windowst *wbm;
 int wf=70,hf=230,xf,yf;
 double slv1[]={1.0,10.0,1.0,1.0};
 int i;
 static int vert=0,inve=0,tbla=0,tlar=0,valu=0,fthi=0,nchi=0;
 int wch=w->att&AT_NOCHAN;
 if (wch) { wcmessagexy(x,y,"Window unchangeable!"); return 0; }
 if (w_versch!=NULL) w_ver_quit(w_versch->name,0,0);
 w_versch=w;
 if (w->att&AT_BITMAP) {
  ver_bmpix= w->w>24 ? 2 : 3;
  wf=Max(wf,(w->w)*ver_bmpix+16);
  hf=Max(hf,(w->h)*ver_bmpix+192);
 }
 if (w->x+w->w/2 < w_mx/2) { xf=w->x+w->w+wf; xf=Min(xf,w_mx-wf); }
 else                        { xf=w->x-wf*2;    xf=Max(xf,0); }
 yf=w->y; if (yf+hf>w_my) yf=w_my-hf; else yf=Max(yf,hf/2);
 valu=(w->att&AT_VALUE)!=0,
 vert=(w->att&AT_VERTI)!=0,
 inve=(w->att&AT_INVERT)!=0,
 tbla=(w->att&AT_TBLACK)!=0;
 tlar=(w->att&AT_TLARGE)!=0;
 fthi=(w->att&AT_FRTHIN)!=0;
 nchi=(w->att&AT_NOCHILD)!=0;
 sprintf(ch,"f_w_ver,%d,%d,%d,%d,cyan,nochange,nochild",xf,yf,wf,hf);
 wlayout("column",10,4);
 wcframe(ch,w->name,NULL);
 wlayout("shift",0,-6);
 wcbutton("f_w_ver_move,white,nochange"," Move ",NULL,w_ver_callb);
 wcbutton("f_w_ver_size,white,nochange"," Size ",NULL,w_ver_callb);
 wcslider("f_w_ver_grid,white,nochange,value",slv1,&ver_grid,NULL);
 wlayout("column",10,2);
 wcbutton("f_w_ver_nchi,cyan,nochange,check","nochil",&nchi,w_ver_btcallb);
 if      (w->typ==W_SLIDER)
  wcbutton("f_w_ver_valu,cyan,nochange,check","value ",&valu,w_ver_btcallb);
 else if (w->typ==W_BUTTON) {
  wcbutton("f_w_ver_valu,cyan,nochange,check","check ",&valu,w_ver_btcallb);
  wcbutton("f_w_ver_inve,cyan,nochange,check","invert",&inve,w_ver_btcallb);
 } else if (w->typ==W_FRAME||w->typ==W_LIBOX)
  wcbutton("f_w_ver_fthi,cyan,nochange,check","frthin",&fthi,w_ver_btcallb);
 if (!(w->att&AT_BITMAP)) {
  wcbutton("f_w_ver_vert,cyan,nochange,check","verti ",&vert,w_ver_btcallb);
  wcbutton("f_w_ver_tbla,cyan,nochange,check","tblack",&tbla,w_ver_btcallb);
  wcbutton("f_w_ver_tlar,cyan,nochange,check","tlarge",&tlar,w_ver_btcallb);
 }
 wlayout("row",4,1);
 wbm=wcbutton("f_w_ver_cb0,black,nochange"," ",NULL,NULL);
 wbm->hit=w_ver_colcallb;
 for (i=1;i<16;i++) {
  sprintf(ch,"f_w_ver_cb%d,%s,nochange",i,pattstr[i]);
  wbm=wcbutton(ch," ",NULL,NULL);
  wbm->hit=w_ver_colcallb;
 }
 wlayout("shift",0,10);
 wlayout("column",8,6);
 wcbutton("f_w_ver_quit,,,,16,lightred,nochange"," Close",NULL,w_ver_quit);
 if (w->att&AT_BITMAP) {
  sprintf(ch,"f_w_ver_bitm,,,%d,%d,nochange,frthin",
             (w->w)*ver_bmpix,(w->h)*ver_bmpix);
  wbm=wcframe(ch,"",NULL);
  if (wbm) {
   wbm->draw=w_ver_bmdraw;
   wbm->hit =w_ver_bmcallb;
   w_ver_bmdraw(wbm);
  }
 }
 return 1;
}
#endif
/* End   Designer */

/*       Menue */

/*fct menucallb */
#ifdef MSW
static int menuid1=0,menuidpop=-1,ixmenuid1list=0;
static int menuid1list[20];
const int mmenucblist=200,mnchswitch=1,mnchmulti=2,mnchon=4;
static Wcallb menucblist[200];
static char menuchk   [201];
static char *wmenuname[20];
char        *wmenuhlpt[200];
extern char Menuname[]; /* in msw.c*/
static void menucallb(int id) {
 char *name=Menuname;
 int id1,idm,i;
 if (wmodalorfirst!=firstwindow) return;
 if (id>=0 && id<menuid1) {
  Wcallb mcb=menucblist[id];
  int chk=menuchk[id];
  for (idm=1;idm<ixmenuid1list;idm++) if (menuid1list[idm]>id) break;
  id1=id-menuid1list[idm-1];
  if (menuidpop>=0) {
   for (i=menuidpop;i<menuid1;i++)
    if (wmenuhlpt[i]) { free(wmenuhlpt[i]); wmenuhlpt[i]=NULL; }
   menuid1=menuidpop; menuidpop=-1; ixmenuid1list--;
  }
  if (chk&(mnchmulti+mnchswitch)) {
   int n=strlen(Menuname)+1;
   while (n--) Menuname[n]=Menuname[n-1];
   if ((chk&mnchmulti) && !(chk&mnchon)) {
    int j=id-1;
    while (menuchk[j]&mnchmulti) {
     if (menuchk[j]&mnchon) { msw_menuchk(j,0); menuchk[j]^=mnchon; }
     j--;
    }
    j=id+1;
    while (menuchk[j]&mnchmulti) {
     if (menuchk[j]&mnchon) { msw_menuchk(j,0); menuchk[j]^=mnchon; }
     j++;
    }
   }
   chk^=mnchon;
   menuchk[id]=chk;
   Menuname[0]= (chk&mnchmulti) ? ((chk&mnchon) ?Cmultiswon:Cmultiswoff)
                                : ((chk&mnchon) ?Cswitchon:Cswitchoff);
   msw_menuchk(id,(chk&mnchon)!=0);
  }
  if (mcb) (mcb)(name,id1,idm);
 }
}
/*
static void menuselect(int id) {
 if (id>=0 && id<menuid1 && wmenuhlpt[id])
  wsetstatustext(wmenuhlpt[id]);
} */
void wmenupopxy(int x,int y) {
 msw_popupxy(x,y);
}
#else
static int menupopx,menupopy;
void wmenupopxy(int x,int y) {
 menupopx=x;menupopy=y;
}
static void menucallb(char *stname,int i,int j) {
 Windowst *st=wfindname(NULL,stname);
 Liboxst *lst=(Liboxst *)(st->ptr);
 char **ptext=lst->data;
 int k=i-1,n=lst->ndata;
 char *text=ptext[k];
 switch(*text) {
   case Cswitchon:  *text=Cswitchoff; break;
   case Cswitchoff: *text=Cswitchon;  break;
   case Cmultiswoff:while (k>0 && *ptext[k]==Cmultiswoff) k--;
                    if (k>0 && *ptext[k]==Cmultiswon) *ptext[k]=Cmultiswoff;
                    k++;
                    while (k<n && *ptext[k]==Cmultiswoff) k++;
                    if (k<n && *ptext[k]==Cmultiswon) *ptext[k]=Cmultiswoff;
                    *text=Cmultiswon; break;
   case Cmultiswon: *text=Cmultiswoff;break;
 }
 if (lst->cbl[i-1]) {
  Wcallb cb=lst->cbl[i-1];
  char *cp=wmktext(ptext[i-1]);
  if (st->att&AT_CLOSEM) wpclose(st);
  if (cb) (cb)(cp,i,0);
  free(cp);
 }
 return;
}
#endif
/*fct w_menuadd */
static Windowst * w_menuadd(int popup,char *s,Wcallb *mcb) {
 int menuy=-yvermenu;
 Windowst *w=NULL;
 Liboxst *lst;
 int x,y,i,n,np=0;
 char *chp,ch[100],mnam[1500],*mnl[50],*mnlht[50];
 strncpy(mnam,s,        1500);
 n=strlen(mnam);
 for (i=0;i<n;i++) {
  if      (mnam[i]==',') { mnam[i]=0; mnl[np++]  =mnam+i+1; mnlht[np-1]=NULL; }
  else if (mnam[i]=='|') { mnam[i]=0; if (np) mnlht[np-1]=mnam+i+1; }
 }
#ifdef MSW
 mnl[np]=NULL;
 i=strlen(mnam); chp=malloc(i+1); if (chp) strcpy(chp,mnam);
 wmenuname[ixmenuid1list]=chp;
 menuid1list[ixmenuid1list++]=menuid1;
 if (popup) menuidpop=menuid1;
 menuchk[menuid1++]=0;
 for (i=0;i<np;i++)
  if (menuid1+i<mmenucblist) {
   int chk=0;
   switch (mnl[i][0]) {
   case Cmultiswoff:chk=mnchmulti;  break;
   case Cswitchoff: chk=mnchswitch; break;
   case Cmultiswon: chk=mnchmulti+mnchon; break;
   case Cswitchon:  chk=mnchswitch+mnchon;
   }
   menucblist[menuid1+i]=mcb[i];
   menuchk   [menuid1+i]=chk;
   chp=mnlht[i];
   if (chp) { chp=malloc(strlen(chp)+1); if (chp) strcpy(chp,mnlht[i]); }
   wmenuhlpt[menuid1+i]=chp;
  }
 msw_menu(popup,mnam,mnl,menuid1);
 menuid1+=np;
 menuchk[menuid1]=0;
 if (popup) {
  int mi=menuidpop;
  while (menuidpop==mi) wloop();
  w=NULL;
 }
#else
 if (popup) {
  if (menupopx>0)
   x=menupopx,y=menupopy;
  else
   x=Lastev.x,y=Lastev.y;
  chp=",frthin,closemodal,nochild";
 } else {
  x=menux,   y=menuy;
  chp=",noframe";
 }
 sprintf(ch,"menu%s,%d,%d,white,tlarge,noslider%s"
         ,mnam,x,y,chp);
 if (popup) { w=wclistbox(ch,mnam,np,mnl,menucallb);
              w->mask|=MM_LMBUP;
 } else       w=wccombobox(ch,mnam,np,mnl,menucallb);
 if (w) {
  char **menhlpt=calloc(np+1,sizeof(char *));
  if (!popup) menux+=w->w;
  lst=w->ptr;
  if (lst) lst->cbl=mcb;
  if (menhlpt) {
   for (i=0;i<np;i++) {
    chp=mnlht[i];
    if (chp) { chp=malloc(strlen(chp)+1); if (chp) strcpy(chp,mnlht[i]); }
    menhlpt[i]=chp;
   }
   w->helptext=menhlpt;
   w->stat|=ST_MENUE;
   w->mask|=MM_MOVE;
  }
 }
 if (w && popup) {
  char name[40];
  strcpy(name,w->name);
  while (wfindname(NULL,name)) wloop();
  w=NULL;
 }
#endif
 return w;
}
/*fct wcmenuadd */
Windowst * wcmenuadd(char *s,Wcallb *mcb) {
 return w_menuadd(0,s,mcb);
}
/*fct wcmenupopup */
Windowst * wcmenupopup(char *s,Wcallb *mcb) {
 return w_menuadd(1,s,mcb);
}
/*fct wnmenuset */
void wnmenuset(char *name,int row,char *p) {
 char *cp=name,ch[40];
 int i=0,im,ima;
 Windowst *w;
#ifndef MSW
 strcpy(ch,"menu");i=4;
#endif
 while (*cp!=0 && *cp!=',' && i<39) ch[i++]=*cp++;
 ch[i]=0;
#ifdef MSW
 for (im=0;im<ixmenuid1list;im++) if (!strcmp(ch,wmenuname[im])) {
  i=-1; ima=menuid1list[im]+row;
  if (!stricmp(p,"on"))  { i=1; menuchk[ima]|=mnchon; }
  if (!stricmp(p,"off")) { i=0; menuchk[ima]&=~mnchon; }
  if (!stricmp(p,"active")) i=3;
  if (!stricmp(p,"inactive")) i=2;
  if (i!=-1) {
   msw_menuchk(ima,i);
  }
  break;
 }
#else
 if ((w=wnfind(ch))!=NULL) {
  Liboxst *lst=w->ptr;
  char **pt=lst->data;
  if (row>0 && row<=lst->ndata) {
   if (!stricmp(p,"on")) {
    if (pt[row-1][0]==Cswitchoff) pt[row-1][0]=Cswitchon;
    if (pt[row-1][0]==Cmultiswoff)pt[row-1][0]=Cmultiswon;
   } else if (!stricmp(p,"off")) {
    if (pt[row-1][0]==Cswitchon)  pt[row-1][0]=Cswitchoff;
    if (pt[row-1][0]==Cmultiswon) pt[row-1][0]=Cmultiswoff;
   } else if (!stricmp(p,"inactive")) {
    pt[row-1][0]=Cinactive;
   } else if (!stricmp(p,"active")) {
    if (pt[row-1][0]==Cinactive) pt[row-1][0]=' ';
   }
  }
 }
#endif
}

/* End   Menue */

/*fct wprinttree */
void wprinttree(Windowst *w,int lev,Windowst *f) {
 Windowst *wn;
 char ch[80];
 int i;
 if (w==NULL) w=wmodalorfirst;
 wn=w->child;
 while (wn) {
  ch[0]=0;
  for (i=0;i<lev;i++) strcat(ch,"  ");
  strcat(ch,wn->name);
  wpboxadd(f,ch,9999);
  wprinttree(wn,lev+1,f);
  wn=wn->next;
 }
}
/*fct winlistcb */
static void winlistcb(char *name,int i,int j) {
 wntotop(name);
}
/*fct winlist */
void winlist(void) {
 Windowst *wn;
 char list[800];
 static Wcallb cbl[21];
 int i=0;
 strcpy(list,"Windowslist");
 wn=firstwindow->child;
 while (wn && i<20) {
  cbl[i++]=winlistcb;
  strcat(list,",");
  strcat(list,wn->name);
  wn=wn->next;
 }
 /*strcat(list,", ");*/ cbl[i]=NULL;
 wcmenupopup(list,cbl);
}

/*fct wgetevmask */
int wgetevmask(void) { return Lastev.mask; }
/*fct wgetevbutton */
int wgetevbutton(void) { return Lastev.buttn; }

/*fct wpsetstatuswin */
void wpsetstatuswin(Windowst *w) {
 wstatus=w;
}
/*fct wsetstatustext */
void wsetstatustext(char *t) {
#ifdef MSW
 msw_statustext(t);
#else
 if (!wstatus) return;
 wpboxdel(wstatus,1);
 if (t) wpboxadd(wstatus,t,0);
 wpdraw(wstatus);
#endif
 wlasthelpt=NULL;
}
/*fct wphelptext */
void wphelptext(Windowst *w,char *t) { w->helptext=t; }
/*fct wnhelptext */
void wnhelptext(char *n,char *t) {
 Windowst *w=wfindname(NULL,n);
 if (w) wphelptext(w,t);
}

/* fct wpsetatt */
int wpsetatt(Windowst *w,char *att) {
 int i;
 for (i=0;i<sizeof(pattstr)/sizeof(char *);i++)
  if (strcmp(att,pattstr[i])==0) {
   if (i<16) w->col=i;
   else w->att^=1<<(i-16);
   w->stat|=ST_CHANG;
   return i+1;
  }
 if (strcmp(att,"visible")==0)   { w->stat&=~ST_INVIS; return 101; }
 if (strcmp(att,"invisible")==0) { w->stat|=ST_INVIS; return 102; }
 return 0;
}
/*fct wnsetatt */
int wnsetatt(char *n,char *att) {
 Windowst *w=wfindname(NULL,n);
 if (w) return wpsetatt(w,att);
 return 0;
}

#define radw 12
#define radh 12
#define f 15
static Pixel rad0[] = {
  7,7,7,7,8,8,8,8,7,7,7,7,
  7,7,8,8,0,0,0,0,8,8,7,7,
  7,8,0,0,7,7,7,7,0,0,f,7,
  7,8,0,7,7,7,7,7,7,7,f,7,
  8,0,7,7,7,7,7,7,7,7,7,f,
  8,0,7,7,7,7,7,7,7,7,7,f,
  8,0,7,7,7,7,7,7,7,7,7,f,
  8,0,7,7,7,7,7,7,7,7,7,f,
  7,8,0,7,7,7,7,7,7,7,f,7,
  7,8,7,7,7,7,7,7,7,7,f,7,
  7,7,f,f,7,7,7,7,f,f,7,7,
  7,7,7,7,f,f,f,f,7,7,7,7};
static Pixel rad1[] = {
  7,7,7,7,8,8,8,8,7,7,7,7,
  7,7,8,8,0,0,0,0,8,8,7,7,
  7,8,0,0,7,7,7,7,0,0,f,7,
  7,8,0,7,7,7,7,7,7,7,f,7,
  8,0,7,7,7,0,0,7,7,7,7,f,
  8,0,7,7,0,0,0,0,7,7,7,f,
  8,0,7,7,0,0,0,0,7,7,7,f,
  8,0,7,7,7,0,0,7,7,7,7,f,
  7,8,0,7,7,7,7,7,7,7,f,7,
  7,8,7,7,7,7,7,7,7,7,f,7,
  7,7,f,f,7,7,7,7,f,f,7,7,
  7,7,7,7,f,f,f,f,7,7,7,7};
#undef f

/*fct radioboxdrw */
static void radioboxdrw(Windowst *frw) {
 int att=frw->att, sta=frw->stat, col=frw->col;
 int bor=att&AT_NOFRAM?2:(att&AT_FRTHIN?6:10);
 int i,j,fb,fh,x,y;
 Pixel *p;
 Pixel pr[radw*radh];
 Liboxst *lst=(Liboxst *)(frw->ptr);
 char **text=(char **)(lst->data);
 framedrw(frw);
 w_fontwhatt(att,col,&fb,&fh);
 fh=(lst->ch-bor)/lst->ndata; y=lst->cy+2; x=lst->cx+2;
 for (i=0;i<lst->ndata;i++) {
  if (lst->rad==i+1) p=rad1; else p=rad0;
  for (j=0;j<radw*radh;j++) pr[j]= p[j]==7 ? col : p[j];
  w_putbox(x,y,radw,radh,pr);
  w_text(x+radw+fb,y+((att&AT_TLARGE)==0?2:0),text[i]);
  y+=fh;
 }
}
/*fct radiocallb */
static int radiocallb(Windowst *frw,Evstack *ev) {
 int att=frw->att, sta=frw->stat, col=frw->col;
 int bor=att&AT_NOFRAM?2:(att&AT_FRTHIN?6:10);
 int i,j,fb,fh,x,y;
 Pixel *p;
 Pixel pr[radw*radh];
 Liboxst *lst=(Liboxst *)(frw->ptr);
 if (!(ev->mask&MM_LMBDOWN)) return 1;
 w_fontwhatt(att,col,&fb,&fh);
 fh=(lst->ch-bor)/lst->ndata; y=lst->cy+2; x=lst->cx+2;
 i=(ev->y-y)/fh; if (i<0 || i>=lst->ndata || i==lst->rad-1) return;
 if (lst->rad!=0) {
  p=rad0;
  for (j=0;j<radw*radh;j++) pr[j]= p[j]==7 ? col : p[j];
  w_putbox(x,y+(lst->rad-1)*fh,radw,radh,pr);
 }
  p=rad1;
  for (j=0;j<radw*radh;j++) pr[j]= p[j]==7 ? col : p[j];
  w_putbox(x,y+i*fh,radw,radh,pr);
 lst->rad=i+1;
 if (lst->callb) (lst->callb)(frw->name,i+1,0);
}
/*fct wcradiobox */
Windowst *wcradiobox(char *par,char *text,int ntext,int an,char **ptext,Wcallb callb) {
 Windowst *win=NULL;
 int i,x,y,w,h,att,col,fh,fb,bor;
 char *name;
 Liboxst *lst=(Liboxst *)malloc(sizeof(Liboxst));
 if (lst) {
  namxywhatt(par,&name,&x,&y,&w,&h,&att,&col);
  bor=att&AT_NOFRAM?2:(att&AT_FRTHIN?6:10);
  w_fontwhatt(att,col,&fb,&fh); fh=Max(fh+2,radh);
  if (w<0) {
   if (text!=NULL) w=strlen(text); else w=4;
   for (i=0;i<ntext;i++) w=Max(w,strlen(ptext[i]));
   w=(w+3)*fb+radw;
  }
  if (h<0) h=(fh+2)*ntext+bor; else fh=(h-bor)/ntext-2;
  lst->text=wmktext(text); lst->callb=callb; lst->rad=an;
  win=window(name,x,y,w,h,att,col,W_LIBOX,lst);
  if (win) {
   frameclient(win);
   lst->data=(void *)wmkptext(ptext,ntext); lst->ndata=ntext;
   win->draw=radioboxdrw;
   win->hit=radiocallb;
   radioboxdrw(win);
  } else { free((void *)name); free((void *)lst); lst=NULL; }
 }
 return win;
}
